	component DE5a_NET_QSYS is
		port (
			in_port_to_the_button                       : in    std_logic_vector(3 downto 0) := (others => 'X'); -- export
			clk_50                                      : in    std_logic                    := 'X';             -- clk
			reset_n                                     : in    std_logic                    := 'X';             -- reset_n
			out_port_from_the_led                       : out   std_logic_vector(3 downto 0);                    -- export
			pmonitor_alert_external_connection_export   : in    std_logic                    := 'X';             -- export
			pmonitor_i2c_scl_external_connection_export : out   std_logic;                                       -- export
			pmonitor_i2c_sda_external_connection_export : inout std_logic                    := 'X';             -- export
			ref_clock_ddr3_count_clk_in_ref_export      : in    std_logic                    := 'X';             -- export
			ref_clock_ddr3_count_clk_in_target_export   : in    std_logic                    := 'X';             -- export
			ref_clock_pcie_count_clk_in_ref_export      : in    std_logic                    := 'X';             -- export
			ref_clock_pcie_count_clk_in_target_export   : in    std_logic                    := 'X';             -- export
			ref_clock_qdrii_count_clk_in_ref_export     : in    std_logic                    := 'X';             -- export
			ref_clock_qdrii_count_clk_in_target_export  : in    std_logic                    := 'X';             -- export
			ref_clock_qsfpa_count_clk_in_ref_export     : in    std_logic                    := 'X';             -- export
			ref_clock_qsfpa_count_clk_in_target_export  : in    std_logic                    := 'X';             -- export
			ref_clock_qsfpb_count_clk_in_ref_export     : in    std_logic                    := 'X';             -- export
			ref_clock_qsfpb_count_clk_in_target_export  : in    std_logic                    := 'X';             -- export
			ref_clock_qsfpc_count_clk_in_ref_export     : in    std_logic                    := 'X';             -- export
			ref_clock_qsfpc_count_clk_in_target_export  : in    std_logic                    := 'X';             -- export
			ref_clock_qsfpd_count_clk_in_ref_export     : in    std_logic                    := 'X';             -- export
			ref_clock_qsfpd_count_clk_in_target_export  : in    std_logic                    := 'X';             -- export
			si5340a_i2c_scl_external_connection_export  : out   std_logic;                                       -- export
			si5340a_i2c_sda_external_connection_export  : inout std_logic                    := 'X';             -- export
			si5340a_oe_n_external_connection_export     : out   std_logic;                                       -- export
			si5340a_rst_external_connection_export      : out   std_logic;                                       -- export
			si5340b_i2c_scl_external_connection_export  : out   std_logic;                                       -- export
			si5340b_i2c_sda_external_connection_export  : inout std_logic                    := 'X';             -- export
			si5340b_oe_n_external_connection_export     : out   std_logic;                                       -- export
			si5340b_rst_external_connection_export      : out   std_logic;                                       -- export
			sw_external_connection_export               : in    std_logic_vector(1 downto 0) := (others => 'X'); -- export
			in_port_to_the_temp_int_n                   : in    std_logic                    := 'X';             -- export
			in_port_to_the_temp_overt_n                 : in    std_logic                    := 'X';             -- export
			temp_scl_external_connection_export         : out   std_logic;                                       -- export
			temp_sda_external_connection_export         : inout std_logic                    := 'X'              -- export
		);
	end component DE5a_NET_QSYS;

	u0 : component DE5a_NET_QSYS
		port map (
			in_port_to_the_button                       => CONNECTED_TO_in_port_to_the_button,                       --           button_external_connection.export
			clk_50                                      => CONNECTED_TO_clk_50,                                      --                        clk_50_clk_in.clk
			reset_n                                     => CONNECTED_TO_reset_n,                                     --                  clk_50_clk_in_reset.reset_n
			out_port_from_the_led                       => CONNECTED_TO_out_port_from_the_led,                       --              led_external_connection.export
			pmonitor_alert_external_connection_export   => CONNECTED_TO_pmonitor_alert_external_connection_export,   --   pmonitor_alert_external_connection.export
			pmonitor_i2c_scl_external_connection_export => CONNECTED_TO_pmonitor_i2c_scl_external_connection_export, -- pmonitor_i2c_scl_external_connection.export
			pmonitor_i2c_sda_external_connection_export => CONNECTED_TO_pmonitor_i2c_sda_external_connection_export, -- pmonitor_i2c_sda_external_connection.export
			ref_clock_ddr3_count_clk_in_ref_export      => CONNECTED_TO_ref_clock_ddr3_count_clk_in_ref_export,      --      ref_clock_ddr3_count_clk_in_ref.export
			ref_clock_ddr3_count_clk_in_target_export   => CONNECTED_TO_ref_clock_ddr3_count_clk_in_target_export,   --   ref_clock_ddr3_count_clk_in_target.export
			ref_clock_pcie_count_clk_in_ref_export      => CONNECTED_TO_ref_clock_pcie_count_clk_in_ref_export,      --      ref_clock_pcie_count_clk_in_ref.export
			ref_clock_pcie_count_clk_in_target_export   => CONNECTED_TO_ref_clock_pcie_count_clk_in_target_export,   --   ref_clock_pcie_count_clk_in_target.export
			ref_clock_qdrii_count_clk_in_ref_export     => CONNECTED_TO_ref_clock_qdrii_count_clk_in_ref_export,     --     ref_clock_qdrii_count_clk_in_ref.export
			ref_clock_qdrii_count_clk_in_target_export  => CONNECTED_TO_ref_clock_qdrii_count_clk_in_target_export,  --  ref_clock_qdrii_count_clk_in_target.export
			ref_clock_qsfpa_count_clk_in_ref_export     => CONNECTED_TO_ref_clock_qsfpa_count_clk_in_ref_export,     --     ref_clock_qsfpa_count_clk_in_ref.export
			ref_clock_qsfpa_count_clk_in_target_export  => CONNECTED_TO_ref_clock_qsfpa_count_clk_in_target_export,  --  ref_clock_qsfpa_count_clk_in_target.export
			ref_clock_qsfpb_count_clk_in_ref_export     => CONNECTED_TO_ref_clock_qsfpb_count_clk_in_ref_export,     --     ref_clock_qsfpb_count_clk_in_ref.export
			ref_clock_qsfpb_count_clk_in_target_export  => CONNECTED_TO_ref_clock_qsfpb_count_clk_in_target_export,  --  ref_clock_qsfpb_count_clk_in_target.export
			ref_clock_qsfpc_count_clk_in_ref_export     => CONNECTED_TO_ref_clock_qsfpc_count_clk_in_ref_export,     --     ref_clock_qsfpc_count_clk_in_ref.export
			ref_clock_qsfpc_count_clk_in_target_export  => CONNECTED_TO_ref_clock_qsfpc_count_clk_in_target_export,  --  ref_clock_qsfpc_count_clk_in_target.export
			ref_clock_qsfpd_count_clk_in_ref_export     => CONNECTED_TO_ref_clock_qsfpd_count_clk_in_ref_export,     --     ref_clock_qsfpd_count_clk_in_ref.export
			ref_clock_qsfpd_count_clk_in_target_export  => CONNECTED_TO_ref_clock_qsfpd_count_clk_in_target_export,  --  ref_clock_qsfpd_count_clk_in_target.export
			si5340a_i2c_scl_external_connection_export  => CONNECTED_TO_si5340a_i2c_scl_external_connection_export,  --  si5340a_i2c_scl_external_connection.export
			si5340a_i2c_sda_external_connection_export  => CONNECTED_TO_si5340a_i2c_sda_external_connection_export,  --  si5340a_i2c_sda_external_connection.export
			si5340a_oe_n_external_connection_export     => CONNECTED_TO_si5340a_oe_n_external_connection_export,     --     si5340a_oe_n_external_connection.export
			si5340a_rst_external_connection_export      => CONNECTED_TO_si5340a_rst_external_connection_export,      --      si5340a_rst_external_connection.export
			si5340b_i2c_scl_external_connection_export  => CONNECTED_TO_si5340b_i2c_scl_external_connection_export,  --  si5340b_i2c_scl_external_connection.export
			si5340b_i2c_sda_external_connection_export  => CONNECTED_TO_si5340b_i2c_sda_external_connection_export,  --  si5340b_i2c_sda_external_connection.export
			si5340b_oe_n_external_connection_export     => CONNECTED_TO_si5340b_oe_n_external_connection_export,     --     si5340b_oe_n_external_connection.export
			si5340b_rst_external_connection_export      => CONNECTED_TO_si5340b_rst_external_connection_export,      --      si5340b_rst_external_connection.export
			sw_external_connection_export               => CONNECTED_TO_sw_external_connection_export,               --               sw_external_connection.export
			in_port_to_the_temp_int_n                   => CONNECTED_TO_in_port_to_the_temp_int_n,                   --       temp_int_n_external_connection.export
			in_port_to_the_temp_overt_n                 => CONNECTED_TO_in_port_to_the_temp_overt_n,                 --     temp_overt_n_external_connection.export
			temp_scl_external_connection_export         => CONNECTED_TO_temp_scl_external_connection_export,         --         temp_scl_external_connection.export
			temp_sda_external_connection_export         => CONNECTED_TO_temp_sda_external_connection_export          --         temp_sda_external_connection.export
		);

