// ============================================================================
// Copyright (c) 2015 by Terasic Technologies Inc.
// ============================================================================
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// ============================================================================
//           
//  Terasic Technologies Inc
//  9F., No.176, Sec.2, Gongdao 5th Rd, East Dist, Hsinchu City, 30070. Taiwan
//  
//  
//                     web: http://www.terasic.com/  
//                     email: support@terasic.com
//
// ============================================================================
//Date:  Tue May  5 10:41:22 2015
// ============================================================================

//`define ENABLE_DDR3A
//`define ENABLE_DDR3B
//`define ENABLE_PCIE
//`define ENABLE_QDRIIA
//`define ENABLE_QDRIIB
//`define ENABLE_QDRIIC
//`define ENABLE_QDRIID
`define ENABLE_QSFPA
`define ENABLE_QSFPB
`define ENABLE_QSFPC
`define ENABLE_QSFPD
`define DDR3A_RANK_NUM   1  //2
`define DDR3B_RANK_NUM   1  //2

module NIOS_BASIC_DEMO(

	//////////// KEY //////////
	input 		     [3:0]		BUTTON,
	input 		          		CPU_RESET_n,
	
	input              			DDR3A_REFCLK_p,
	input              			QDRIIA_REFCLK_p,
	input              			OB_PCIE_REFCLK_p,

	//////////// CLOCK //////////
	input 		          		CLKUSR_100,
	input 		          		CLK_100_B3D,
	input 		          		CLK_50_B2J,
	input 		          		CLK_50_B2L,
	input 		          		CLK_50_B3D,
	input 		          		CLK_50_B3F,
	input 		          		CLK_50_B3H,

	//////////// SW //////////
	input 		     [1:0]		SW,

	//////////// LED //////////
	output		     [3:0]		LED,

	//////////// LED_BRACKET //////////
	output		     [3:0]		LED_BRACKET,

	//////////// SEG7 //////////
	output		          		HEX0_DP,
	output		     [6:0]		HEX0_D,
	output		          		HEX1_DP,
	output		     [6:0]		HEX1_D,

`ifdef ENABLE_DDR3A
	//////////// DDR3 SODIMM, DDR3 SODIMM_A //////////
	output		    [15:0]		DDR3A_A,
	output		     [2:0]		DDR3A_BA,
	output		          		DDR3A_CAS_n,
    output      [(`DDR3A_RANK_NUM-1):0]  DDR3A_CK,
    output      [(`DDR3A_RANK_NUM-1):0]  DDR3A_CKE,
    output      [(`DDR3A_RANK_NUM-1):0]  DDR3A_CK_n,
    output      [(`DDR3A_RANK_NUM-1):0]  DDR3A_CS_n,
	output		     [7:0]		DDR3A_DM,
	inout 		    [63:0]		DDR3A_DQ,
	inout 		     [7:0]		DDR3A_DQS,
	inout 		     [7:0]		DDR3A_DQS_n,
	input 		          		DDR3A_EVENT_n,
    output      [(`DDR3A_RANK_NUM-1):0]  DDR3A_ODT,
	output		          		DDR3A_RAS_n,
	//input 		          		DDR3A_REFCLK_p,
	output		          		DDR3A_RESET_n,
	output		          		DDR3A_SCL,
	inout 		          		DDR3A_SDA,
	output		          		DDR3A_WE_n,
`endif /*ENABLE_DDR3A*/

`ifdef ENABLE_DDR3B
	//////////// DDR3 SODIMM, DDR3 SODIMM_B //////////
	output		    [15:0]		DDR3B_A,
	output		     [2:0]		DDR3B_BA,
	output		          		DDR3B_CAS_n,
    output      [(`DDR3B_RANK_NUM-1):0]   DDR3B_CK,
    output      [(`DDR3B_RANK_NUM-1):0]   DDR3B_CKE,
    output      [(`DDR3B_RANK_NUM-1):0]   DDR3B_CK_n,
    output      [(`DDR3B_RANK_NUM-1):0]   DDR3B_CS_n,
	output		     [7:0]		DDR3B_DM,
	inout 		    [63:0]		DDR3B_DQ,
	inout 		     [7:0]		DDR3B_DQS,
	inout 		     [7:0]		DDR3B_DQS_n,
	input 		          		DDR3B_EVENT_n,
    output      [(`DDR3B_RANK_NUM-1):0]   DDR3B_ODT,
	output		          		DDR3B_RAS_n,
	//input 		          		DDR3B_REFCLK_p,
	output		          		DDR3B_RESET_n,
	output		          		DDR3B_SCL,
	inout 		          		DDR3B_SDA,
	output		          		DDR3B_WE_n,
`endif /*ENABLE_DDR3B*/

	//////////// FAN //////////
	input 		          		FAN_ALERT_n,
	output		          		FAN_I2C_SCL,
	inout 		          		FAN_I2C_SDA,

	//////////// FLASH //////////
	output		          		FLASH_ADV_n,
	output		    [26:1]		FLASH_A,
	output		     [1:0]		FLASH_CE_n,
	output		          		FLASH_CLK,
	inout 		    [31:0]		FLASH_D,
	inout 		          		FLASH_OE_n,
	input 		     [1:0]		FLASH_RDY_BSY_n,
	output		          		FLASH_RESET_n,
	output		          		FLASH_WE_n,

`ifdef ENABLE_PCIE
	///////// OB /////////
    input              			OB_PCIE_REFCLK_p,
	//////////// PCIE //////////
	input 		          		PCIE_PERST_n,
	input 		          		PCIE_REFCLK_p,
	input 		     [7:0]		PCIE_RX_p,
	input 		          		PCIE_SMBCLK,
	inout 		          		PCIE_SMBDAT,
	output		     [7:0]		PCIE_TX_p,
	output		          		PCIE_WAKE_n,
`endif /*ENABLE_PCIE*/


	//////////// POWER Monitor //////////
	input 		          		POWER_MONITOR_ALERT,
	output		          		POWER_MONITOR_I2C_SCL,
	inout 		          		POWER_MONITOR_I2C_SDA,

`ifdef ENABLE_QDRIIA
	//////////// QDRIIA //////////
	output		    [21:0]		QDRIIA_A,
	output		     [1:0]		QDRIIA_BWS_n,
	input 		          		QDRIIA_CQ_n,
	input 		          		QDRIIA_CQ_p,
	output		          		QDRIIA_DOFF_n,
	output		    [17:0]		QDRIIA_D,
	output		          		QDRIIA_K_n,
	output		          		QDRIIA_K_p,
	output		          		QDRIIA_ODT,
	input 		          		QDRIIA_QVLD,
	input 		    [17:0]		QDRIIA_Q,
	input 		          		QDRIIA_REFCLK_p,
	output		          		QDRIIA_RPS_n,
	output		          		QDRIIA_WPS_n,
`endif /*ENABLE_QDRIIA*/

`ifdef ENABLE_QDRIIB
	//////////// QDRIIB //////////
	output		    [21:0]		QDRIIB_A,
	output		     [1:0]		QDRIIB_BWS_n,
	input 		          		QDRIIB_CQ_n,
	input 		          		QDRIIB_CQ_p,
	output		          		QDRIIB_DOFF_n,
	output		    [17:0]		QDRIIB_D,
	output		          		QDRIIB_K_n,
	output		          		QDRIIB_K_p,
	output		          		QDRIIB_ODT,
	input 		          		QDRIIB_QVLD,
	input 		    [17:0]		QDRIIB_Q,
	input 		          		QDRIIB_REFCLK_p,
	output		          		QDRIIB_RPS_n,
	output		          		QDRIIB_WPS_n,
`endif /*ENABLE_QDRIIB*/

`ifdef ENABLE_QDRIIC
	//////////// QDRIIC //////////
	output		    [21:0]		QDRIIC_A,
	output		     [1:0]		QDRIIC_BWS_n,
	input 		          		QDRIIC_CQ_n,
	input 		          		QDRIIC_CQ_p,
	output		          		QDRIIC_DOFF_n,
	output		    [17:0]		QDRIIC_D,
	output		          		QDRIIC_K_n,
	output		          		QDRIIC_K_p,
	output		          		QDRIIC_ODT,
	input 		          		QDRIIC_QVLD,
	input 		    [17:0]		QDRIIC_Q,
	input 		          		QDRIIC_REFCLK_p,
	output		          		QDRIIC_RPS_n,
	output		          		QDRIIC_WPS_n,
`endif /*ENABLE_QDRIIC*/

`ifdef ENABLE_QDRIID
	//////////// QDRIID //////////
	output		    [21:0]		QDRIID_A,
	output		     [1:0]		QDRIID_BWS_n,
	input 		          		QDRIID_CQ_n,
	input 		          		QDRIID_CQ_p,
	output		          		QDRIID_DOFF_n,
	output		    [17:0]		QDRIID_D,
	output		          		QDRIID_K_n,
	output		          		QDRIID_K_p,
	output		          		QDRIID_ODT,
	input 		          		QDRIID_QVLD,
	input 		    [17:0]		QDRIID_Q,
	input 		          		QDRIID_REFCLK_p,
	output		          		QDRIID_RPS_n,
	output		          		QDRIID_WPS_n,
`endif /*ENABLE_QDRIID*/

`ifdef ENABLE_QSFPA
	//////////// QSFPA //////////
	input 		          		QSFPA_INTERRUPT_n,
	output		          		QSFPA_LP_MODE,
	input 		          		QSFPA_MOD_PRS_n,
	output		          		QSFPA_MOD_SEL_n,
	input 		          		QSFPA_REFCLK_p,
	output		          		QSFPA_RST_n,
	input 		     [3:0]		QSFPA_RX_p,
	output		          		QSFPA_SCL,
	inout 		          		QSFPA_SDA,
	output		     [3:0]		QSFPA_TX_p,
`endif /*ENABLE_QSFPA*/

`ifdef ENABLE_QSFPB
	//////////// QSFPB //////////
	input 		          		QSFPB_INTERRUPT_n,
	input 		          		QSFPB_LP_MODE,
	output		          		QSFPB_MOD_PRS_n,
	output		          		QSFPB_MOD_SEL_n,
	input 		          		QSFPB_REFCLK_p,
	output		          		QSFPB_RST_n,
	input 		     [3:0]		QSFPB_RX_p,
	output		          		QSFPB_SCL,
	inout 		          		QSFPB_SDA,
	output		     [3:0]		QSFPB_TX_p,
`endif /*ENABLE_QSFPB*/

`ifdef ENABLE_QSFPC
	//////////// QSFPC //////////
	input 		          		QSFPC_INTERRUPT_n,
	input 		          		QSFPC_LP_MODE,
	output		          		QSFPC_MOD_PRS_n,
	output		          		QSFPC_MOD_SEL_n,
	input 		          		QSFPC_REFCLK_p,
	output		          		QSFPC_RST_n,
	input 		     [3:0]		QSFPC_RX_p,
	output		          		QSFPC_SCL,
	inout 		          		QSFPC_SDA,
	output		     [3:0]		QSFPC_TX_p,
`endif /*ENABLE_QSFPC*/

`ifdef ENABLE_QSFPD
	//////////// QSFPD //////////
	input 		          		QSFPD_INTERRUPT_n,
	input 		          		QSFPD_LP_MODE,
	output		          		QSFPD_MOD_PRS_n,
	output		          		QSFPD_MOD_SEL_n,
	input 		          		QSFPD_REFCLK_p,
	output		          		QSFPD_RST_n,
	input 		     [3:0]		QSFPD_RX_p,
	output		          		QSFPD_SCL,
	inout 		          		QSFPD_SDA,
	output		     [3:0]		QSFPD_TX_p,
`endif /*ENABLE_QSFPD*/

	//////////// RS422 //////////
	output		          		RJ45_LED_L,
	output		          		RJ45_LED_R,
	output		          		RS422_DE,
	input 		          		RS422_DIN,
	output		          		RS422_DOUT,
	output		          		RS422_RE_n,

	//////////// RZQ //////////
	input 		          		RZQ_DDR3_A,
	input 		          		RZQ_DDR3_B,
	input 		          		RZQ_QDRII_A,
	input 		          		RZQ_QDRII_B,
	input 		          		RZQ_QDRII_C,
	input 		          		RZQ_QDRII_D,
	
      ///////// SI5340A /////////
    output             			SI5340A_I2C_SCL,
    inout              			SI5340A_I2C_SDA,
    input              			SI5340A_INTR,
    output             			SI5340A_OE_n,
    output             			SI5340A_RST_n,

      ///////// SI5340B /////////
    output             			SI5340B_I2C_SCL,
    inout              			SI5340B_I2C_SDA,
    input              			SI5340B_INTR,
    output             			SI5340B_OE_n,
    output             			SI5340B_RST_n,

	//////////// SMA //////////
	input 		          		SMA_CLKIN,
	output		          		SMA_CLKOUT,

	//////////// Temperature //////////
	output		          		TEMP_I2C_SCL,
	inout 		          		TEMP_I2C_SDA,
	input 		          		TEMP_INT_n,
	input 		          		TEMP_OVERT_n,
	
    ///////// TPS40422 /////////
    input              			TPS40422_ALERT,
    output             			TPS40422_CLK,
    inout              			TPS40422_DATA	
);


//=======================================================
//  REG/WIRE declarations
//=======================================================
wire reset_n;
wire [13:0] HEX_DATA;
wire  [12:0] Speed_Switch;


//=======================================================
//  Structural coding
//=======================================================
assign  Speed_Switch = 13'd5000;
assign  HEX0_DP = 1;
assign  HEX1_DP = 1;

Fan_Control u0
(
 	.CLK(CLK_50_B2J),
 	.RST_N(BUTTON[0]),
   .Speed_Set(Speed_Switch),//need set more than 1500rpm
	.Speed_Detected(HEX_DATA),
	.Alert_Clear(BUTTON[1]),
	.Alert_Type(LED),
	.Alert(FAN_ALERT_n),
	.FAN_I2C_SCL(FAN_I2C_SCL),
	.FAN_I2C_SDA(FAN_I2C_SDA)
);
//=======================================================
//  Structural coding
//=======================================================

assign reset_n = CPU_RESET_n;

  DE5a_NET_QSYS u1 (
        .clk_50                                          (CLK_50_B3D),                // clk_50_clk_in.clk
        .reset_n                                         (reset_n),                   // clk_50_clk_in_reset.reset_n
		  
		  // temperature
        .temp_scl_external_connection_export             (TEMP_I2C_SCL),              // temp_clk_external_connection.export
        .temp_sda_external_connection_export             (TEMP_I2C_SDA),              // temp_data_external_connection.export
        .in_port_to_the_temp_int_n                       (TEMP_INT_n),                // temp_int_n_external_connection.export
        .in_port_to_the_temp_overt_n                     (TEMP_OVERT_n),              // temp_overt_n_external_connection.export
		  
		  // generic io
        //.in_port_to_the_button                           (BUTTON),                    // button_external_connection.export
        //.out_port_from_the_led                           (LED),                       // led_external_connection.export
       // .sw_external_connection_export                   (SW),                   	  // sw_external_connection.export
		  .si5340a_oe_n_external_connection_export         (SI5340A_OE_n),              // si5340a_oe_n_external_connection.export
        .si5340a_rst_external_connection_export          (SI5340A_RST_n),               // si5340a_rst_external_connection.export
        .si5340b_oe_n_external_connection_export         (SI5340B_OE_n),              // si5340b_oe_n_external_connection.export
        .si5340b_rst_external_connection_export          (SI5340B_RST_n),               // si5340b_rst_external_connection.export
		  
		  .si5340a_i2c_scl_external_connection_export      (SI5340A_I2C_SCL), 			  // si5340a_i2c_scl_external_connection.export
        .si5340a_i2c_sda_external_connection_export      (SI5340A_I2C_SDA),           // si5340a_i2c_sda_external_connection.export
      
        .si5340b_i2c_scl_external_connection_export      (SI5340B_I2C_SCL),           // si5340b_i2c_scl_external_connection.export
        .si5340b_i2c_sda_external_connection_export      (SI5340B_I2C_SDA),           // si5340b_i2c_sda_external_connection.export
		  
		  .pmonitor_alert_external_connection_export       (POWER_MONITOR_ALERT),       // pmonitor_alert_external_connection.export
		  .pmonitor_i2c_scl_external_connection_export     (POWER_MONITOR_I2C_SCL),     // pmonitor_i2c_scl_external_connection.export
		  .pmonitor_i2c_sda_external_connection_export     (POWER_MONITOR_I2C_SDA),     // pmonitor_i2c_sda_external_connection.export
				  
		  // external clock measure
		  .ref_clock_qsfpa_count_clk_in_ref_export         (CLK_50_B3D),    				  // ref_clock_qsfpa_count_clk_in_ref.export
        .ref_clock_qsfpa_count_clk_in_target_export      (QSFPA_REFCLK_p),            // ref_clock_qsfpa_count_clk_in_target.export
        .ref_clock_qsfpb_count_clk_in_ref_export         (CLK_50_B3D),                // ref_clock_qsfpb_count_clk_in_ref.export
        .ref_clock_qsfpb_count_clk_in_target_export      (QSFPB_REFCLK_p),            // ref_clock_qsfpb_count_clk_in_target.export
        .ref_clock_qsfpc_count_clk_in_ref_export         (CLK_50_B3D),    				  // ref_clock_qsfpc_count_clk_in_ref.export
        .ref_clock_qsfpc_count_clk_in_target_export      (QSFPC_REFCLK_p), 			  // ref_clock_qsfpc_count_clk_in_target.export
        .ref_clock_qsfpd_count_clk_in_ref_export         (CLK_50_B3D),    				  // ref_clock_qsfpd_count_clk_in_ref.export
        .ref_clock_qsfpd_count_clk_in_target_export      (QSFPD_REFCLK_p),  			  // ref_clock_qsfpd_count_clk_in_target.export
		  .ref_clock_ddr3_count_clk_in_ref_export          (CLK_50_B3D),                // ref_clock_ddr3_count_clk_in_ref.export
        .ref_clock_ddr3_count_clk_in_target_export       (DDR3A_REFCLK_p),  			  // ref_clock_ddr3_count_clk_in_target.export
        .ref_clock_pcie_count_clk_in_ref_export          (CLK_50_B3D),     			  // ref_clock_pcie_count_clk_in_ref.export
        .ref_clock_pcie_count_clk_in_target_export       (OB_PCIE_REFCLK_p),  		  // ref_clock_pcie_count_clk_in_target.export
        .ref_clock_qdrii_count_clk_in_ref_export         (CLK_50_B3D),                // ref_clock_qdrii_count_clk_in_ref.export
		  .ref_clock_qdrii_count_clk_in_target_export      (QDRIIA_REFCLK_p)     		  // ref_clock_qdrii_count_clk_in_target.export
                      		  
    );

////////////////////////////////////////
// Dummy xcvr to avoid compile error
xcvr_4ch_native_phy xcvr_4ch_native_phy_sfpa(
		.reconfig_clk   (QSFPA_REFCLK_p), // reconfig_clk.clk
		.tx_serial_data (QSFPA_TX_p),     // tx_serial_data.tx_serial_data
		.rx_serial_data (QSFPA_RX_p)      // rx_serial_data.rx_serial_data		  
	);	 

xcvr_4ch_native_phy xcvr_4ch_native_phy_sfpb(
		.reconfig_clk   (QSFPB_REFCLK_p), // reconfig_clk.clk
		.tx_serial_data (QSFPB_TX_p),     // tx_serial_data.tx_serial_data
		.rx_serial_data (QSFPB_RX_p)      // rx_serial_data.rx_serial_data		  
	);	 
	
xcvr_4ch_native_phy xcvr_4ch_native_phy_sfpc(
		.reconfig_clk   (QSFPC_REFCLK_p), // reconfig_clk.clk
		.tx_serial_data (QSFPC_TX_p),     // tx_serial_data.tx_serial_data
		.rx_serial_data (QSFPC_RX_p)      // rx_serial_data.rx_serial_data		  
	);	 
	
xcvr_4ch_native_phy xcvr_4ch_native_phy_sfpd(
		.reconfig_clk   (QSFPD_REFCLK_p), // reconfig_clk.clk
		.tx_serial_data (QSFPD_TX_p),     // tx_serial_data.tx_serial_data
		.rx_serial_data (QSFPD_RX_p)      // rx_serial_data.rx_serial_data		  
	);	 
        
	



endmodule
