// --------------------------------------------------------------------
// Copyright (c) 2008 by Terasic Technologies Inc. 
// --------------------------------------------------------------------
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// --------------------------------------------------------------------
//           
//                     Terasic Technologies Inc
//                     356 Fu-Shin E. Rd Sec. 1. JhuBei City,
//                     HsinChu County, Taiwan
//                     302
//
//                     web: http://www.terasic.com/
//                     email: support@terasic.com
//
// --------------------------------------------------------------------

#ifndef IN231_H_
#define IN231_H_


//==Pointer NUM==
//-WRITE/READ-
#define P_Configuration 	0x00
#define P_Calibration   	0x05
#define P_Mask_Enable   	0x06
#define P_Alert_Limit   	0x07
//-READ-
#define P_Shunt_Voltage 	0x01
#define P_Bus_Voltage  		0x02
#define P_Power         	0x03
#define P_Current       	0x04
#define P_Die_ID       	    0xff
//Register Configuration
#define Configuration_Reg   0x4327  //AVG---4    conversion time---1.1ms   Mode-----Shunt and Bus, continuou
#define Calibration_Reg     0xd55   //Current_LSB=500uA/bit    RSHUNT=3mOhm   Calibration=3413=d55h

#define Monitor_I2C_ADRESS  0x80 // 1000_000 + Write bit 0
//Configure/Measure/Calculate
//P_Shunt_Voltage*2.5uv/1000=Shunt_Voltage(mV)
//P_Bus_Voltage*1.25mV/1000=Bus_Voltage(V)
//P_Current*0.5mA/1000=Current(A)
//P_Power*0.5mA*25/1000=Power(W)


#endif /*IN231_H_*/
