
#include "terasic_includes.h"
#include "i2c.h"
#include "si5340B_config.h"

//#define SI5430_DEBUG(x)    DEBUG(x)

typedef struct{
	int FreqID;
	float DDR3_FREQUENCY;
	float PCIE_FREQUENCY;
	float QDRII_FREQUENCY;
}Si5340B_CONFIG;


Si5340B_CONFIG gszGi5340B_ConfigTable[] = {
		{SI5340_CASE0, 		266.667, 100.0, 275.0},
		{SI5340_CASE1, 		233.333, 100.0, 275.0},
		{SI5340_CASE2, 	    200.0,   100.0, 275.0},
		{SI5340_CASE3, 		266.667, 100.0, 250.0},
		{SI5340_CASE4, 		233.333, 100.0, 250.0},
		{SI5340_CASE5,      200.0,   100.0, 250.0},
		{SI5340_CASE6, 	    266.667, 100.0, 225.0},
		{SI5340_CASE7,      233.333, 100.0, 225.0},
		{SI5340_CASE8, 	    200.0,   100.0, 225.0},
		{SI5340_CASE9, 		266.667, 100.0, 233.333},
		{SI5340_CASE10, 	233.333, 100.0, 233.333},
		{SI5340_CASE11, 	200.0,   100.0, 233.333},

};



bool si5340B_find_DIV_NI(SI5340B_FREQ_ID FreqID, double *pfFreq0, double *pfFreq1, double *pfFreq2){
	bool bFind = FALSE;
	int i;

	for(i=0;i<sizeof(gszGi5340B_ConfigTable)/sizeof(gszGi5340B_ConfigTable[0]) && !bFind;i++){
		if (gszGi5340B_ConfigTable[i].FreqID == FreqID){
			bFind = TRUE;
			*pfFreq0 = gszGi5340B_ConfigTable[i].DDR3_FREQUENCY;
			*pfFreq1 = gszGi5340B_ConfigTable[i].PCIE_FREQUENCY;
			*pfFreq2 = gszGi5340B_ConfigTable[i].QDRII_FREQUENCY;
		}
	} // for

	return bFind;

}


bool SI5340B_Config_Init(void){
	 bool bSuccess = TRUE;
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_PAGE, 0x00); //page  0
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_0018, REGB_0018);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_0021, REGB_0021);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_PAGE, 0x01); //page  1
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_0102, REGB_0102);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_0113, REGB_0113);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_0114, REGB_0114);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_0115, REGB_0115);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_0118, REGB_0118);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_0119, REGB_0119);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_011A, REGB_011A);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_0127, REGB_0127);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_0128, REGB_0128);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_0129, REGB_0129);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_012C, REGB_012C);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_012D, REGB_012D);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_012E, REGB_012E);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_0141, REGB_0141);

	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_PAGE, 0x02); //page  2
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_0235, REGB_0235);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_0236, REGB_0236);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_0237, REGB_0237);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_0238, REGB_0238);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_0239, REGB_0239);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_023A, REGB_023A);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_023B, REGB_023B);
	        if (bSuccess)
	            bSuccess = SI5340B_w_reg(REGB_ADDR_023C, REGB_023C);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_023D, REGB_023D);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_023E, REGB_023E);

	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_PAGE, 0x09); //page  9
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_090E, REGB_090E);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_091C, REGB_091C);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_0949, REGB_0949);
	        if (bSuccess)
	        	bSuccess = SI5340B_w_reg(REGB_ADDR_094A, REGB_094A);

			if (bSuccess)
	        	 bSuccess = SI5340B_w_reg(REGB_ADDR_PAGE, 0x0A); //page  A
	         if (bSuccess)
	        	 bSuccess = SI5340B_w_reg(REGB_ADDR_0A03, REGB_0A03);
	         if (bSuccess)
	        	 bSuccess = SI5340B_w_reg(REGB_ADDR_0A04, REGB_0A04);
	         if (bSuccess)
	        	 bSuccess = SI5340B_w_reg(REGB_ADDR_0A05, REGB_0A05);

			if (bSuccess)
	        	 bSuccess = SI5340B_w_reg(REGB_ADDR_PAGE, 0x0B); //page  B
	         if (bSuccess)
	        	 bSuccess = SI5340B_w_reg(REGB_ADDR_0B44, REGB_0B44);
	         if (bSuccess)
	        	 bSuccess = SI5340B_w_reg(REGB_ADDR_0B4A, REGB_0B4A);
	   DEBUG(("[SI5430] SI5340B_Config_Init %s\r\n", bSuccess?"success":"fail"));

	    return bSuccess;
 }


bool SI5340B_Config(SI5340B_FREQ_ID FreqID){
	bool bSuccess;
	bool OUT0_OE=1,OUT1_OE=1,OUT2_OE=1,OUT3_OE=0;
	alt_u8  RX_Reg[98];
	//alt_u8 dataR1;
	alt_u8  NX_Num_Den[34];
	alt_u8  REG_0112,REG_0117,REG_0126,REG_012B;
	double  fFreq0, fFreq1, fFreq2;
	alt_u32 R0_REG=0, R1_REG=0, R2_REG=0;
	alt_u64 N0_NUM, N1_NUM, N2_NUM;
	alt_u64 N0_DEN = 0x80000000;
	alt_u64 N1_DEN = 0x80000000;
	alt_u64 N2_DEN = 0xB0000000;
	int n;

	bSuccess = si5340B_find_DIV_NI(FreqID, &fFreq0, &fFreq1, &fFreq2);

	if (!bSuccess){
		printf("This not my preset freq id (%d)\r\n", FreqID);
		return FALSE;
	}

	if (bSuccess){

		N0_NUM =(6800*N0_DEN)/fFreq0;
		N1_NUM =(6800*N1_DEN)/fFreq1;
		N2_NUM =(6800*N2_DEN)/fFreq2;

		REG_0112 = OUT0_OE ? 0x06 : 0x04;
		REG_0117 = OUT1_OE ? 0x06 : 0x04;
		REG_0126 = OUT2_OE ? 0x06 : 0x04;
		REG_012B = OUT3_OE ? 0x06 : 0x04;

		RX_Reg[83]      = (R0_REG >> 0 ) & 0xff;
		RX_Reg[84]      = (R0_REG >> 8 ) & 0xff;
		RX_Reg[85]      = (R0_REG >> 16) & 0xff;
		RX_Reg[86]      = (R1_REG >> 0 ) & 0xff;
		RX_Reg[87]      = (R1_REG >> 8 ) & 0xff;
		RX_Reg[88]      = (R1_REG >> 16) & 0xff;

		RX_Reg[95]      = (R2_REG >> 0 ) & 0xff;
		RX_Reg[96]      = (R2_REG >> 8 ) & 0xff;
		RX_Reg[97]      = (R2_REG >> 16) & 0xff;


		NX_Num_Den[2]   = (N0_NUM >> 0 ) & 0xff;
		NX_Num_Den[3]   = (N0_NUM >> 8 ) & 0xff;
		NX_Num_Den[4]   = (N0_NUM >> 16) & 0xff;
		NX_Num_Den[5]   = (N0_NUM >> 24) & 0xff;
		NX_Num_Den[6]   = (N0_NUM >> 32) & 0xff;
		NX_Num_Den[7]   = (N0_NUM >> 40) & 0x0f;
		NX_Num_Den[8]   = (N0_DEN >> 0 ) & 0xff;
		NX_Num_Den[9]   = (N0_DEN >> 8 ) & 0xff;
		NX_Num_Den[10]  = (N0_DEN >> 16) & 0xff;
		NX_Num_Den[11]  = (N0_DEN >> 24) & 0xff;

		NX_Num_Den[13]  = (N1_NUM >> 0 ) & 0xff;
		NX_Num_Den[14]  = (N1_NUM >> 8 ) & 0xff;
		NX_Num_Den[15]  = (N1_NUM >> 16) & 0xff;
		NX_Num_Den[16]  = (N1_NUM >> 24) & 0xff;
		NX_Num_Den[17]  = (N1_NUM >> 32) & 0xff;
		NX_Num_Den[18]  = (N1_NUM >> 40) & 0x0f;
		NX_Num_Den[19]  = (N1_DEN >> 0 ) & 0xff;
		NX_Num_Den[20]  = (N1_DEN >> 8 ) & 0xff;
		NX_Num_Den[21]  = (N1_DEN >> 16) & 0xff;
		NX_Num_Den[22]  = (N1_DEN >> 24) & 0xff;

		NX_Num_Den[24]  = (N2_NUM >> 0 ) & 0xff;
		NX_Num_Den[25]  = (N2_NUM >> 8 ) & 0xff;
		NX_Num_Den[26]  = (N2_NUM >> 16) & 0xff;
		NX_Num_Den[27]  = (N2_NUM >> 24) & 0xff;
		NX_Num_Den[28]  = (N2_NUM >> 32) & 0xff;
		NX_Num_Den[29]  = (N2_NUM >> 40) & 0x0f;
		NX_Num_Den[30]  = (N2_DEN >> 0 ) & 0xff;
		NX_Num_Den[31]  = (N2_DEN >> 8 ) & 0xff;
		NX_Num_Den[32]  = (N2_DEN >> 16) & 0xff;
		NX_Num_Den[33]  = (N2_DEN >> 24) & 0xff;


	}
	if (bSuccess)
        bSuccess = SI5340B_w_reg(REGB_ADDR_PAGE, 0x01); //page  1
	if (bSuccess)
        bSuccess = SI5340B_w_reg(REGB_ADDR_0112, REG_0112);
    if (bSuccess)
        bSuccess = SI5340B_w_reg(REGB_ADDR_0117, REG_0117);
    if (bSuccess)
        bSuccess = SI5340B_w_reg(REGB_ADDR_0126, REG_0126);
	if (bSuccess)
        bSuccess = SI5340B_w_reg(REGB_ADDR_012B, REG_012B);

	if (bSuccess)
        bSuccess = SI5340B_w_reg(REGB_ADDR_PAGE, 0x02); //page  2
	if (bSuccess){
		// Write the new frequency configuration (R0_REG/R1_REG)
		for(n=83;n<=88 && bSuccess;n++){
			bSuccess = SI5340B_w_reg( n, RX_Reg[n]);
		}

		// Write the new frequency configuration (R2_REG/R3_REG)
		for(n=95;n<=97 && bSuccess;n++){
			bSuccess = SI5340B_w_reg( n, RX_Reg[n]);
		}
	}
	if (bSuccess)
		bSuccess = I2C_Write(SI5340B_I2C_SCL_BASE, SI5340B_I2C_SDA_BASE, SI5340B_DeviceAddr, REGB_ADDR_023F, 0x01);//M_Update
	if (bSuccess)
        bSuccess = SI5340B_w_reg(REGB_ADDR_PAGE, 0x03); //page  3
	if (bSuccess){
		// Write the new frequency configuration (N0_NUM/N0_DEN)
		for(n=2;n<=11 && bSuccess;n++){
			bSuccess = SI5340B_w_reg( n, NX_Num_Den[n]);
		}
		// Write the new frequency configuration (N1_NUM/N1_DEN)
		for(n=13;n<=22 && bSuccess;n++){
			bSuccess = SI5340B_w_reg( n, NX_Num_Den[n]);
		}
		// Write the new frequency configuration (N2_NUM/N2_DEN)
		for(n=24;n<=33 && bSuccess;n++){
			bSuccess = SI5340B_w_reg( n, NX_Num_Den[n]);
		}

	}
	if (bSuccess)
		bSuccess = I2C_Write(SI5340B_I2C_SCL_BASE, SI5340B_I2C_SDA_BASE, SI5340B_DeviceAddr, REGB_ADDR_030C, 0x01);//N0_Update
	if (bSuccess)
		bSuccess = I2C_Write(SI5340B_I2C_SCL_BASE, SI5340B_I2C_SDA_BASE, SI5340B_DeviceAddr, REGB_ADDR_0317, 0x01);//N1_Update
	if (bSuccess)
		bSuccess = I2C_Write(SI5340B_I2C_SCL_BASE, SI5340B_I2C_SDA_BASE, SI5340B_DeviceAddr, REGB_ADDR_0322, 0x01);//N2_Update
	if (bSuccess)
		bSuccess = I2C_Write(SI5340B_I2C_SCL_BASE, SI5340B_I2C_SDA_BASE, SI5340B_DeviceAddr, REGB_ADDR_032D, 0x01);//N3_Update
	if (bSuccess)
		bSuccess = I2C_Write(SI5340B_I2C_SCL_BASE, SI5340B_I2C_SDA_BASE, SI5340B_DeviceAddr, REGB_ADDR_0338, 0x01);//N_Update
	if (bSuccess)
        bSuccess = SI5340B_w_reg(REGB_ADDR_0339, 0x1F);
    if (bSuccess)
    	bSuccess = SI5340B_w_reg(REGB_ADDR_PAGE, 0x00); //page  0
    if (bSuccess)
    	bSuccess = I2C_Write(SI5340B_I2C_SCL_BASE, SI5340B_I2C_SDA_BASE, SI5340B_DeviceAddr, REGB_ADDR_001C, 0x01); //soft reset
	DEBUG(("[SI5430] SI5340B_Configuration %s\r\n", bSuccess?"success":"fail"));


return bSuccess;
}


bool SI5340B_w_reg (alt_u8 reg_index, alt_u8 data8){

	bool bSuccess = TRUE;
	alt_u8 dataR;
    if (bSuccess){
        bSuccess = I2C_Write(SI5340B_I2C_SCL_BASE, SI5340B_I2C_SDA_BASE, SI5340B_DeviceAddr, reg_index, data8);
    }
    usleep(50*1000);
     if (bSuccess){
     	bSuccess = I2C_Read(SI5340B_I2C_SCL_BASE, SI5340B_I2C_SDA_BASE, SI5340B_DeviceAddr, reg_index, &dataR);
     	//printf("[SI5430] read reg[%02xh] = %02Xh\r\n", reg_index, dataR );
     }


 	if (!bSuccess){
 				printf("SI5430: failed to read page register\r\n");
 	}
	else{
		      if (dataR !=data8)
		      {
    	        bSuccess = FALSE;
    	        DEBUG(("[SI5430] read  reg[%02x] = %04Xh\r\n", reg_index, dataR ));
              }
	     }

	return bSuccess;


}
