
# (C) 2001-2016 Altera Corporation. All rights reserved.
# Your use of Altera Corporation's design tools, logic functions and 
# other software and tools, and its AMPP partner logic functions, and 
# any output files any of the foregoing (including device programming 
# or simulation files), and any associated documentation or information 
# are expressly subject to the terms and conditions of the Altera 
# Program License Subscription Agreement, Altera MegaCore Function 
# License Agreement, or other applicable license agreement, including, 
# without limitation, that your use is for the sole purpose of 
# programming logic devices manufactured by Altera and sold by Altera 
# or its authorized distributors. Please refer to the applicable 
# agreement for further details.

# ACDS 15.1 193 win32 2016.03.25.11:19:16

# ----------------------------------------
# ncsim - auto-generated simulation script

# ----------------------------------------
# This script can be used to simulate the following IP:
#     xcvr_4ch_native_phy
# To create a top-level simulation script which compiles other
# IP, and manages other system issues, copy the following template
# and adapt it to your needs:
# 
# # Start of template
# # If the copied and modified template file is "ncsim.sh", run it as:
# #   ./ncsim.sh
# #
# # Do the file copy, dev_com and com steps
# source ncsim_setup.sh \
# SKIP_ELAB=1 \
# SKIP_SIM=1
# 
# # Compile the top level module
# ncvlog -sv "$QSYS_SIMDIR/../top.sv"
# 
# # Do the elaboration and sim steps
# # Override the top-level name
# # Override the user-defined sim options, so the simulation
# # runs forever (until $finish()).
# source ncsim_setup.sh \
# SKIP_FILE_COPY=1 \
# SKIP_DEV_COM=1 \
# SKIP_COM=1 \
# TOP_LEVEL_NAME=top \
# USER_DEFINED_SIM_OPTIONS=""
# # End of template
# ----------------------------------------
# If xcvr_4ch_native_phy is one of several IP cores in your
# Quartus project, you can generate a simulation script
# suitable for inclusion in your top-level simulation
# script by running the following command line:
# 
# ip-setup-simulation --quartus-project=<quartus project>
# 
# ip-setup-simulation will discover the Altera IP
# within the Quartus project, and generate a unified
# script which supports all the Altera IP within the design.
# ----------------------------------------
# ACDS 15.1 193 win32 2016.03.25.11:19:16
# ----------------------------------------
# initialize variables
TOP_LEVEL_NAME="xcvr_4ch_native_phy"
QSYS_SIMDIR="./../"
QUARTUS_INSTALL_DIR="C:/altera/15.1/quartus/"
SKIP_FILE_COPY=0
SKIP_DEV_COM=0
SKIP_COM=0
SKIP_ELAB=0
SKIP_SIM=0
USER_DEFINED_ELAB_OPTIONS=""
USER_DEFINED_SIM_OPTIONS="-input \"@run 100; exit\""

# ----------------------------------------
# overwrite variables - DO NOT MODIFY!
# This block evaluates each command line argument, typically used for 
# overwriting variables. An example usage:
#   sh <simulator>_setup.sh SKIP_ELAB=1 SKIP_SIM=1
for expression in "$@"; do
  eval $expression
  if [ $? -ne 0 ]; then
    echo "Error: This command line argument, \"$expression\", is/has an invalid expression." >&2
    exit $?
  fi
done

# ----------------------------------------
# initialize simulation properties - DO NOT MODIFY!
ELAB_OPTIONS=""
SIM_OPTIONS=""
if [[ `ncsim -version` != *"ncsim(64)"* ]]; then
  :
else
  :
fi

# ----------------------------------------
# create compilation libraries
mkdir -p ./libraries/work/
mkdir -p ./libraries/altera_common_sv_packages/
mkdir -p ./libraries/xcvr_4ch_native_phy_altera_xcvr_native_a10_151/
mkdir -p ./libraries/altera_ver/
mkdir -p ./libraries/lpm_ver/
mkdir -p ./libraries/sgate_ver/
mkdir -p ./libraries/altera_mf_ver/
mkdir -p ./libraries/altera_lnsim_ver/
mkdir -p ./libraries/twentynm_ver/
mkdir -p ./libraries/twentynm_hssi_ver/
mkdir -p ./libraries/twentynm_hip_ver/

# ----------------------------------------
# copy RAM/ROM files to simulation directory

# ----------------------------------------
# compile device library files
if [ $SKIP_DEV_COM -eq 0 ]; then
  ncvlog $USER_DEFINED_COMPILE_OPTIONS     "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_primitives.v"                  -work altera_ver       
  ncvlog $USER_DEFINED_COMPILE_OPTIONS     "$QUARTUS_INSTALL_DIR/eda/sim_lib/220model.v"                           -work lpm_ver          
  ncvlog $USER_DEFINED_COMPILE_OPTIONS     "$QUARTUS_INSTALL_DIR/eda/sim_lib/sgate.v"                              -work sgate_ver        
  ncvlog $USER_DEFINED_COMPILE_OPTIONS     "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_mf.v"                          -work altera_mf_ver    
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_lnsim.sv"                      -work altera_lnsim_ver 
  ncvlog $USER_DEFINED_COMPILE_OPTIONS     "$QUARTUS_INSTALL_DIR/eda/sim_lib/twentynm_atoms.v"                     -work twentynm_ver     
  ncvlog $USER_DEFINED_COMPILE_OPTIONS     "$QUARTUS_INSTALL_DIR/eda/sim_lib/cadence/twentynm_atoms_ncrypt.v"      -work twentynm_ver     
  ncvlog $USER_DEFINED_COMPILE_OPTIONS     "$QUARTUS_INSTALL_DIR/eda/sim_lib/cadence/twentynm_hssi_atoms_ncrypt.v" -work twentynm_hssi_ver
  ncvlog $USER_DEFINED_COMPILE_OPTIONS     "$QUARTUS_INSTALL_DIR/eda/sim_lib/twentynm_hssi_atoms.v"                -work twentynm_hssi_ver
  ncvlog $USER_DEFINED_COMPILE_OPTIONS     "$QUARTUS_INSTALL_DIR/eda/sim_lib/cadence/twentynm_hip_atoms_ncrypt.v"  -work twentynm_hip_ver 
  ncvlog $USER_DEFINED_COMPILE_OPTIONS     "$QUARTUS_INSTALL_DIR/eda/sim_lib/twentynm_hip_atoms.v"                 -work twentynm_hip_ver 
fi

# ----------------------------------------
# compile design files in correct order
if [ $SKIP_COM -eq 0 ]; then
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_151/sim/altera_xcvr_native_a10_functions_h.sv"                     -work altera_common_sv_packages                      -cdslib ./cds_libs/altera_common_sv_packages.cds.lib                     
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_151/sim/alt_xcvr_resync.sv"                                        -work xcvr_4ch_native_phy_altera_xcvr_native_a10_151 -cdslib ./cds_libs/xcvr_4ch_native_phy_altera_xcvr_native_a10_151.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_151/sim/alt_xcvr_arbiter.sv"                                       -work xcvr_4ch_native_phy_altera_xcvr_native_a10_151 -cdslib ./cds_libs/xcvr_4ch_native_phy_altera_xcvr_native_a10_151.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_151/sim/twentynm_pcs.sv"                                           -work xcvr_4ch_native_phy_altera_xcvr_native_a10_151 -cdslib ./cds_libs/xcvr_4ch_native_phy_altera_xcvr_native_a10_151.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_151/sim/twentynm_pma.sv"                                           -work xcvr_4ch_native_phy_altera_xcvr_native_a10_151 -cdslib ./cds_libs/xcvr_4ch_native_phy_altera_xcvr_native_a10_151.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_151/sim/twentynm_xcvr_avmm.sv"                                     -work xcvr_4ch_native_phy_altera_xcvr_native_a10_151 -cdslib ./cds_libs/xcvr_4ch_native_phy_altera_xcvr_native_a10_151.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_151/sim/twentynm_xcvr_native.sv"                                   -work xcvr_4ch_native_phy_altera_xcvr_native_a10_151 -cdslib ./cds_libs/xcvr_4ch_native_phy_altera_xcvr_native_a10_151.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_151/sim/a10_avmm_h.sv"                                             -work xcvr_4ch_native_phy_altera_xcvr_native_a10_151 -cdslib ./cds_libs/xcvr_4ch_native_phy_altera_xcvr_native_a10_151.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_151/sim/alt_xcvr_native_pipe_retry.sv"                             -work xcvr_4ch_native_phy_altera_xcvr_native_a10_151 -cdslib ./cds_libs/xcvr_4ch_native_phy_altera_xcvr_native_a10_151.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_151/sim/alt_xcvr_native_avmm_csr.sv"                               -work xcvr_4ch_native_phy_altera_xcvr_native_a10_151 -cdslib ./cds_libs/xcvr_4ch_native_phy_altera_xcvr_native_a10_151.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_151/sim/alt_xcvr_native_prbs_accum.sv"                             -work xcvr_4ch_native_phy_altera_xcvr_native_a10_151 -cdslib ./cds_libs/xcvr_4ch_native_phy_altera_xcvr_native_a10_151.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_151/sim/alt_xcvr_native_odi_accel.sv"                              -work xcvr_4ch_native_phy_altera_xcvr_native_a10_151 -cdslib ./cds_libs/xcvr_4ch_native_phy_altera_xcvr_native_a10_151.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_151/sim/alt_xcvr_native_rcfg_arb.sv"                               -work xcvr_4ch_native_phy_altera_xcvr_native_a10_151 -cdslib ./cds_libs/xcvr_4ch_native_phy_altera_xcvr_native_a10_151.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_151/sim/reconfig/altera_xcvr_native_a10_reconfig_parameters.sv"    -work xcvr_4ch_native_phy_altera_xcvr_native_a10_151 -cdslib ./cds_libs/xcvr_4ch_native_phy_altera_xcvr_native_a10_151.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_151/sim/xcvr_4ch_native_phy_altera_xcvr_native_a10_151_6si7gxa.sv" -work xcvr_4ch_native_phy_altera_xcvr_native_a10_151 -cdslib ./cds_libs/xcvr_4ch_native_phy_altera_xcvr_native_a10_151.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_151/sim/alt_xcvr_native_rcfg_opt_logic_6si7gxa.sv"                 -work xcvr_4ch_native_phy_altera_xcvr_native_a10_151 -cdslib ./cds_libs/xcvr_4ch_native_phy_altera_xcvr_native_a10_151.cds.lib
  ncvlog -compcnfg $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/xcvr_4ch_native_phy.v"                                                                                                                                                                                                     
fi

# ----------------------------------------
# elaborate top level design
if [ $SKIP_ELAB -eq 0 ]; then
  ncelab -access +w+r+c -namemap_mixgen $ELAB_OPTIONS $USER_DEFINED_ELAB_OPTIONS $TOP_LEVEL_NAME
fi

# ----------------------------------------
# simulate
if [ $SKIP_SIM -eq 0 ]; then
  eval ncsim -licqueue $SIM_OPTIONS $USER_DEFINED_SIM_OPTIONS $TOP_LEVEL_NAME
fi
