// ============================================================================
// Copyright (c) 2015 by Terasic Technologies Inc.
// ============================================================================
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// ============================================================================
//           
//  Terasic Technologies Inc
//  9F., No.176, Sec.2, Gongdao 5th Rd, East Dist, Hsinchu City, 30070. Taiwan
//  
//  
//                     web: http://www.terasic.com/  
//                     email: support@terasic.com
//
// ============================================================================
//Date:  Fri Sep 12 11:54:52 2014
// ============================================================================

//`define ENABLE_DDR3A
//`define ENABLE_DDR3B
//`define ENABLE_PCIE
//`define ENABLE_QDRIIA
//`define ENABLE_QDRIIB
//`define ENABLE_QDRIIC
//`define ENABLE_QDRIID
//`define ENABLE_QSFPA
//`define ENABLE_QSFPB
//`define ENABLE_QSFPC
//`define ENABLE_QSFPD
`define DDR3A_RANK_NUM   1  //2
`define DDR3B_RANK_NUM   1  //2

module DE5A_NET(


      ///////// BUTTON /////////
      input       [3:0]  BUTTON,

      ///////// CLK /////////
      input              CLK_50_B2J,
      input              CLK_50_B2L,
      input              CLK_50_B3D,
      input              CLK_50_B3F,
      input              CLK_50_B3H,
      input              CLK_100_B3D,
      input 	       	 CLKUSR_100,

      ///////// CPU /////////
      input              CPU_RESET_n,

`ifdef ENABLE_DDR3A
      ///////// DDR3A /////////
      output      [15:0] DDR3A_A,
      output      [2:0]  DDR3A_BA,
      output             DDR3A_CAS_n,
      output      [(`DDR3A_RANK_NUM-1):0]  DDR3A_CK,
      output      [(`DDR3A_RANK_NUM-1):0]  DDR3A_CKE,
      output      [(`DDR3A_RANK_NUM-1):0]  DDR3A_CK_n,
      output      [(`DDR3A_RANK_NUM-1):0]  DDR3A_CS_n,
      output      [7:0]  DDR3A_DM,
      inout       [63:0] DDR3A_DQ,
      inout       [7:0]  DDR3A_DQS,
      inout       [7:0]  DDR3A_DQS_n,
      input              DDR3A_EVENT_n,
      output      [(`DDR3A_RANK_NUM-1):0]  DDR3A_ODT,
      output             DDR3A_RAS_n,
      input              DDR3A_REFCLK_p,
      output             DDR3A_RESET_n,
      output             DDR3A_SCL,
      inout              DDR3A_SDA,
      output             DDR3A_WE_n,
`endif /*ENABLE_DDR3A*/


`ifdef ENABLE_DDR3B
      ///////// DDR3B /////////
      output      [15:0] DDR3B_A,
      output      [2:0]  DDR3B_BA,
      output             DDR3B_CAS_n,
      output      [(`DDR3B_RANK_NUM-1):0]   DDR3B_CK,
      output      [(`DDR3B_RANK_NUM-1):0]   DDR3B_CKE,
      output      [(`DDR3B_RANK_NUM-1):0]   DDR3B_CK_n,
      output      [(`DDR3B_RANK_NUM-1):0]   DDR3B_CS_n,
      output      [7:0]  DDR3B_DM,
      inout       [63:0] DDR3B_DQ,
      inout       [7:0]  DDR3B_DQS,
      inout       [7:0]  DDR3B_DQS_n,
      input              DDR3B_EVENT_n,
      output      [(`DDR3B_RANK_NUM-1):0]   DDR3B_ODT,
      output             DDR3B_RAS_n,
      input              DDR3B_REFCLK_p,
      output             DDR3B_RESET_n,
      output             DDR3B_SCL,
      inout              DDR3B_SDA,
      output             DDR3B_WE_n,
`endif /*ENABLE_DDR3B*/

      ///////// FAN /////////
      input              FAN_ALERT_n,
      output             FAN_I2C_SCL,
      inout              FAN_I2C_SDA,

      ///////// FLASH /////////
      output      [26:1] FLASH_A,
      output             FLASH_ADV_n,
      output      [1:0]  FLASH_CE_n,
      output             FLASH_CLK,
      inout       [31:0] FLASH_D,
      inout              FLASH_OE_n,
      input       [1:0]  FLASH_RDY_BSY_n,
      output             FLASH_RESET_n,
      output             FLASH_WE_n,

      ///////// HEX0 /////////
      output      [6:0]  HEX0_D,
      output             HEX0_DP,

      ///////// HEX1 /////////
      output      [6:0]  HEX1_D,
      output             HEX1_DP,

      ///////// LED /////////
      output      [3:0]  LED,
      output      [3:0]  LED_BRACKET,
  
`ifdef ENABLE_PCIE
      ///////// OB /////////
      input              OB_PCIE_REFCLK_p,
      ///////// PCIE /////////
      input              PCIE_PERST_n,
      input              PCIE_REFCLK_p,
      input       [7:0]  PCIE_RX_p,
      input              PCIE_SMBCLK,
      inout              PCIE_SMBDAT,
      output      [7:0]  PCIE_TX_p,
      output             PCIE_WAKE_n,
`endif /*ENABLE_PCIE*/

      ///////// POWER /////////
      input              POWER_MONITOR_ALERT,
      output             POWER_MONITOR_I2C_SCL,
      inout              POWER_MONITOR_I2C_SDA,

`ifdef ENABLE_QDRIIA
      ///////// QDRIIA /////////
      output      [21:0] QDRIIA_A,
      output      [1:0]  QDRIIA_BWS_n,
      input              QDRIIA_CQ_n,
      input              QDRIIA_CQ_p,
      output      [17:0] QDRIIA_D,
      output             QDRIIA_DOFF_n,
      output             QDRIIA_K_n,
      output             QDRIIA_K_p,
      output             QDRIIA_ODT,
      input       [17:0] QDRIIA_Q,
      input              QDRIIA_QVLD,
      input              QDRIIA_REFCLK_p,
      output             QDRIIA_RPS_n,
      output             QDRIIA_WPS_n,
`endif /*ENABLE_QDRIIA*/

`ifdef ENABLE_QDRIIB
      ///////// QDRIIB /////////
      output      [21:0] QDRIIB_A,
      output      [1:0]  QDRIIB_BWS_n,
      input              QDRIIB_CQ_n,
      input              QDRIIB_CQ_p,
      output      [17:0] QDRIIB_D,
      output             QDRIIB_DOFF_n,
      output             QDRIIB_K_n,
      output             QDRIIB_K_p,
      output             QDRIIB_ODT,
      input       [17:0] QDRIIB_Q,
      input              QDRIIB_QVLD,
      input              QDRIIB_REFCLK_p,
      output             QDRIIB_RPS_n,
      output             QDRIIB_WPS_n,
`endif /*ENABLE_QDRIIB*/

`ifdef ENABLE_QDRIIC
      ///////// QDRIIC /////////
      output      [21:0] QDRIIC_A,
      output      [1:0]  QDRIIC_BWS_n,
      input              QDRIIC_CQ_n,
      input              QDRIIC_CQ_p,
      output      [17:0] QDRIIC_D,
      output             QDRIIC_DOFF_n,
      output             QDRIIC_K_n,
      output             QDRIIC_K_p,
      output             QDRIIC_ODT,
      input       [17:0] QDRIIC_Q,
      input              QDRIIC_QVLD,
      input              QDRIIC_REFCLK_p,
      output             QDRIIC_RPS_n,
      output             QDRIIC_WPS_n,
`endif /*ENABLE_QDRIIC*/

`ifdef ENABLE_QDRIID
      ///////// QDRIID /////////
      output      [21:0] QDRIID_A,
      output      [1:0]  QDRIID_BWS_n,
      input              QDRIID_CQ_n,
      input              QDRIID_CQ_p,
      output      [17:0] QDRIID_D,
      output             QDRIID_DOFF_n,
      output             QDRIID_K_n,
      output             QDRIID_K_p,
      output             QDRIID_ODT,
      input       [17:0] QDRIID_Q,
      input              QDRIID_QVLD,
      input              QDRIID_REFCLK_p,
      output             QDRIID_RPS_n,
      output             QDRIID_WPS_n,
`endif /*ENABLE_QDRIID*/

`ifdef ENABLE_QSFPA
      ///////// QSFPA /////////
      input              QSFPA_INTERRUPT_n,
      output             QSFPA_LP_MODE,
      input              QSFPA_MOD_PRS_n,
      output             QSFPA_MOD_SEL_n,
      input              QSFPA_REFCLK_p,
      output             QSFPA_RST_n,
      input       [3:0]  QSFPA_RX_p,
      output             QSFPA_SCL,
      inout              QSFPA_SDA,
      output      [3:0]  QSFPA_TX_p,
`endif /*ENABLE_QSFPA*/

`ifdef ENABLE_QSFPB
      ///////// QSFPB /////////
      input              QSFPB_INTERRUPT_n,
      output             QSFPB_LP_MODE,
      input              QSFPB_MOD_PRS_n,
      output             QSFPB_MOD_SEL_n,
      input              QSFPB_REFCLK_p,
      output             QSFPB_RST_n,
      input       [3:0]  QSFPB_RX_p,
      output             QSFPB_SCL,
      inout              QSFPB_SDA,
      output      [3:0]  QSFPB_TX_p,
`endif /*ENABLE_QSFPB*/

`ifdef ENABLE_QSFPC
      ///////// QSFPC /////////
      input              QSFPC_INTERRUPT_n,
      output             QSFPC_LP_MODE,
      input              QSFPC_MOD_PRS_n,
      output             QSFPC_MOD_SEL_n,
      input              QSFPC_REFCLK_p,
      output             QSFPC_RST_n,
      input       [3:0]  QSFPC_RX_p,
      output             QSFPC_SCL,
      inout              QSFPC_SDA,
      output      [3:0]  QSFPC_TX_p,
`endif /*ENABLE_QSFPC*/

`ifdef ENABLE_QSFPD
      ///////// QSFPD /////////
      input              QSFPD_INTERRUPT_n,
      output             QSFPD_LP_MODE,
      input              QSFPD_MOD_PRS_n,
      output             QSFPD_MOD_SEL_n,
      input              QSFPD_REFCLK_p,
      output             QSFPD_RST_n,
      input       [3:0]  QSFPD_RX_p,
      output             QSFPD_SCL,
      inout              QSFPD_SDA,
      output      [3:0]  QSFPD_TX_p,
`endif /*ENABLE_QSFPD*/

			//////////// RS422 //////////
			output		          		RJ45_LED_L,
			output		          		RJ45_LED_R,
			output		          		RS422_DE,
			input 		          		RS422_DIN,
			output		          		RS422_DOUT,
			output		          		RS422_RE_n,

      ///////// RZQ /////////
      input              RZQ_DDR3_A,
      input              RZQ_DDR3_B,
      input              RZQ_QDRII_A,
      input              RZQ_QDRII_B,
      input              RZQ_QDRII_C,
      input              RZQ_QDRII_D,

      ///////// SI5340A /////////
      output             SI5340A_I2C_SCL,
      inout              SI5340A_I2C_SDA,
      input              SI5340A_INTR,
      output             SI5340A_OE_n,
      output             SI5340A_RST_n,

      ///////// SI5340B /////////
      output             SI5340B_I2C_SCL,
      inout              SI5340B_I2C_SDA,
      input              SI5340B_INTR,
      output             SI5340B_OE_n,
      output             SI5340B_RST_n,

      ///////// SMA /////////
      input              SMA_CLKIN,
      output             SMA_CLKOUT,

      ///////// SW /////////
      input       [1:0]  SW,

      ///////// TEMP /////////
      output             TEMP_I2C_SCL,
      inout              TEMP_I2C_SDA,
      input              TEMP_INT_n,
      input              TEMP_OVERT_n,

      ///////// TPS40422 /////////
      input              TPS40422_ALERT,
      output             TPS40422_CLK,
      inout              TPS40422_DATA
);



//=======================================================
//  REG/WIRE declarations
//=======================================================




wire [1:0]flash_dummy_addr;
//=======================================================
//  Structural coding
//=======================================================

    QSYS_PFL u0 (
        .sys_clk_clk                                     (CLK_50_B2J),                                     //                    sys_clk.clk
		  .reset_reset_n                                   (CPU_RESET_n),                                   //                           reset.reset_n
        .cfi_flash_atb_bridge_0_out_tcm_address_out      ({FLASH_A, flash_dummy_addr}),      // cfi_flash_atb_bridge_0_out.tcm_address_out
        .cfi_flash_atb_bridge_0_out_tcm_read_n_out       (FLASH_OE_n),       //                           .tcm_read_n_out
        .cfi_flash_atb_bridge_0_out_tcm_write_n_out      (FLASH_WE_n),      //                           .tcm_write_n_out
        .cfi_flash_atb_bridge_0_out_tcm_data_out         (FLASH_D),         //                           .tcm_data_out
        .cfi_flash_atb_bridge_0_out_tcm_chipselect_n_out (FLASH_CE_n[0]), //                           .tcm_chipselect_n_out
        .button_external_connection_export               (BUTTON),               // button_external_connection.export
        .led_external_connection_export                  (LED[3:1]),                  //    led_external_connection.export
        .led_bracket_external_connection_export          (LED_BRACKET[3:0]),             //    led_rj45_external_connection.export
        .hex1_external_connection_export                 ({HEX1_DP, HEX1_D}),                 //     hex1_external_connection.export
        .hex0_external_connection_export                 ({HEX0_DP, HEX0_D}),                 //     hex0_external_connection.export
        .temp_scl_external_connection_export             (TEMP_I2C_SCL),             // temp_scl_external_connection.export
        .temp_sda_external_connection_export             (TEMP_I2C_SDA)              // temp_sda_external_connection.export
		  
    );

	 
// Common Flash interface assignments
assign  FLASH_RESET_n = CPU_RESET_n; // flash ready after FPGA is configured, reset during configuration
assign  FLASH_ADV_n   = 1'b0;
assign  FLASH_CLK    = 1'b0;
assign  FLASH_CE_n[1] = FLASH_CE_n[0]; // select both flash devices for double-wide 32 bit data width
//FLASH_RDY_BSY_n



//
heart_beat heart_beat_clk50(
	.clk(CLK_50_B2J),
	.led(LED[0])
);
defparam heart_beat_clk50.DUR_BITS = 25;


endmodule
