// ============================================================================
// Copyright (c) 2014 by Terasic Technologies Inc.
// ============================================================================
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// ============================================================================
//           
//  Terasic Technologies Inc
//  9F., No.176, Sec.2, Gongdao 5th Rd, East Dist, Hsinchu City, 30070. Taiwan
//  
//  
//                     web: http://www.terasic.com/  
//                     email: support@terasic.com
//
// ============================================================================
// Major Functions:	 QDRII+ x4 Test RTL Test
// ============================================================================
//
// Revision History :
// ============================================================================
//   Ver  :| Author            :| Mod. Date  :| Changes Made:
//   V1.0 :| Dee Zeng          :| 2016/03/31 :| Initial Revision
// ============================================================================

//`define ENABLE_DDR3A
//`define ENABLE_DDR3B
//`define ENABLE_PCIE
`define ENABLE_QDRIIA
`define ENABLE_QDRIIB
`define ENABLE_QDRIIC
`define ENABLE_QDRIID
//`define ENABLE_QSFPA
//`define ENABLE_QSFPB
//`define ENABLE_QSFPC
//`define ENABLE_QSFPD
`define DDR3A_RANK_NUM   1  //2
`define DDR3B_RANK_NUM   1  //2

module DE5A_NET(


      ///////// BUTTON /////////
      input       [3:0]  BUTTON,

      ///////// CLK /////////
      input              CLK_50_B2J,
      input              CLK_50_B2L,
      input              CLK_50_B3D,
      input              CLK_50_B3F,
      input              CLK_50_B3H,
      input              CLK_100_B3D,
      input 	       	 CLKUSR_100,

      ///////// CPU /////////
      input              CPU_RESET_n,

`ifdef ENABLE_DDR3A
      ///////// DDR3A /////////
      output      [15:0] DDR3A_A,
      output      [2:0]  DDR3A_BA,
      output             DDR3A_CAS_n,
      output      [(`DDR3A_RANK_NUM-1):0]  DDR3A_CK,
      output      [(`DDR3A_RANK_NUM-1):0]  DDR3A_CKE,
      output      [(`DDR3A_RANK_NUM-1):0]  DDR3A_CK_n,
      output      [(`DDR3A_RANK_NUM-1):0]  DDR3A_CS_n,
      output      [7:0]  DDR3A_DM,
      inout       [63:0] DDR3A_DQ,
      inout       [7:0]  DDR3A_DQS,
      inout       [7:0]  DDR3A_DQS_n,
      input              DDR3A_EVENT_n,
      output      [(`DDR3A_RANK_NUM-1):0]  DDR3A_ODT,
      output             DDR3A_RAS_n,
      input              DDR3A_REFCLK_p,
      output             DDR3A_RESET_n,
      output             DDR3A_SCL,
      inout              DDR3A_SDA,
      output             DDR3A_WE_n,
`endif /*ENABLE_DDR3A*/


`ifdef ENABLE_DDR3B
      ///////// DDR3B /////////
      output      [15:0] DDR3B_A,
      output      [2:0]  DDR3B_BA,
      output             DDR3B_CAS_n,
      output      [(`DDR3B_RANK_NUM-1):0]   DDR3B_CK,
      output      [(`DDR3B_RANK_NUM-1):0]   DDR3B_CKE,
      output      [(`DDR3B_RANK_NUM-1):0]   DDR3B_CK_n,
      output      [(`DDR3B_RANK_NUM-1):0]   DDR3B_CS_n,
      output      [7:0]  DDR3B_DM,
      inout       [63:0] DDR3B_DQ,
      inout       [7:0]  DDR3B_DQS,
      inout       [7:0]  DDR3B_DQS_n,
      input              DDR3B_EVENT_n,
      output      [(`DDR3B_RANK_NUM-1):0]   DDR3B_ODT,
      output             DDR3B_RAS_n,
      input              DDR3B_REFCLK_p,
      output             DDR3B_RESET_n,
      output             DDR3B_SCL,
      inout              DDR3B_SDA,
      output             DDR3B_WE_n,
`endif /*ENABLE_DDR3B*/

      ///////// FAN /////////
      input              FAN_ALERT_n,
      output             FAN_I2C_SCL,
      inout              FAN_I2C_SDA,

      ///////// FLASH /////////
      output      [26:1] FLASH_A,
      output             FLASH_ADV_n,
      output      [1:0]  FLASH_CE_n,
      output             FLASH_CLK,
      inout       [31:0] FLASH_D,
      inout              FLASH_OE_n,
      input       [1:0]  FLASH_RDY_BSY_n,
      output             FLASH_RESET_n,
      output             FLASH_WE_n,

      ///////// HEX0 /////////
      output      [6:0]  HEX0_D,
      output             HEX0_DP,

      ///////// HEX1 /////////
      output      [6:0]  HEX1_D,
      output             HEX1_DP,

      ///////// LED /////////
      output      [3:0]  LED,
      output      [3:0]  LED_BRACKET,
  
`ifdef ENABLE_PCIE
      ///////// OB /////////
      input              OB_PCIE_REFCLK_p,
      ///////// PCIE /////////
      input              PCIE_PERST_n,
      input              PCIE_REFCLK_p,
      input       [7:0]  PCIE_RX_p,
      input              PCIE_SMBCLK,
      inout              PCIE_SMBDAT,
      output      [7:0]  PCIE_TX_p,
      output             PCIE_WAKE_n,
`endif /*ENABLE_PCIE*/

      ///////// POWER /////////
      input              POWER_MONITOR_ALERT,
      output             POWER_MONITOR_I2C_SCL,
      inout              POWER_MONITOR_I2C_SDA,

`ifdef ENABLE_QDRIIA
      ///////// QDRIIA /////////
      output      [21:0] QDRIIA_A,
      output      [1:0]  QDRIIA_BWS_n,
      input              QDRIIA_CQ_n,
      input              QDRIIA_CQ_p,
      output      [17:0] QDRIIA_D,
      output             QDRIIA_DOFF_n,
      output             QDRIIA_K_n,
      output             QDRIIA_K_p,
      output             QDRIIA_ODT,
      input       [17:0] QDRIIA_Q,
      input              QDRIIA_QVLD,
      input              QDRIIA_REFCLK_p,
      output             QDRIIA_RPS_n,
      output             QDRIIA_WPS_n,
`endif /*ENABLE_QDRIIA*/

`ifdef ENABLE_QDRIIB
      ///////// QDRIIB /////////
      output      [21:0] QDRIIB_A,
      output      [1:0]  QDRIIB_BWS_n,
      input              QDRIIB_CQ_n,
      input              QDRIIB_CQ_p,
      output      [17:0] QDRIIB_D,
      output             QDRIIB_DOFF_n,
      output             QDRIIB_K_n,
      output             QDRIIB_K_p,
      output             QDRIIB_ODT,
      input       [17:0] QDRIIB_Q,
      input              QDRIIB_QVLD,
      input              QDRIIB_REFCLK_p,
      output             QDRIIB_RPS_n,
      output             QDRIIB_WPS_n,
`endif /*ENABLE_QDRIIB*/

`ifdef ENABLE_QDRIIC
      ///////// QDRIIC /////////
      output      [21:0] QDRIIC_A,
      output      [1:0]  QDRIIC_BWS_n,
      input              QDRIIC_CQ_n,
      input              QDRIIC_CQ_p,
      output      [17:0] QDRIIC_D,
      output             QDRIIC_DOFF_n,
      output             QDRIIC_K_n,
      output             QDRIIC_K_p,
      output             QDRIIC_ODT,
      input       [17:0] QDRIIC_Q,
      input              QDRIIC_QVLD,
      input              QDRIIC_REFCLK_p,
      output             QDRIIC_RPS_n,
      output             QDRIIC_WPS_n,
`endif /*ENABLE_QDRIIC*/

`ifdef ENABLE_QDRIID
      ///////// QDRIID /////////
      output      [21:0] QDRIID_A,
      output      [1:0]  QDRIID_BWS_n,
      input              QDRIID_CQ_n,
      input              QDRIID_CQ_p,
      output      [17:0] QDRIID_D,
      output             QDRIID_DOFF_n,
      output             QDRIID_K_n,
      output             QDRIID_K_p,
      output             QDRIID_ODT,
      input       [17:0] QDRIID_Q,
      input              QDRIID_QVLD,
      input              QDRIID_REFCLK_p,
      output             QDRIID_RPS_n,
      output             QDRIID_WPS_n,
`endif /*ENABLE_QDRIID*/

`ifdef ENABLE_QSFPA
      ///////// QSFPA /////////
      input              QSFPA_INTERRUPT_n,
      output             QSFPA_LP_MODE,
      input              QSFPA_MOD_PRS_n,
      output             QSFPA_MOD_SEL_n,
      input              QSFPA_REFCLK_p,
      output             QSFPA_RST_n,
      input       [3:0]  QSFPA_RX_p,
      output             QSFPA_SCL,
      inout              QSFPA_SDA,
      output      [3:0]  QSFPA_TX_p,
`endif /*ENABLE_QSFPA*/

`ifdef ENABLE_QSFPB
      ///////// QSFPB /////////
      input              QSFPB_INTERRUPT_n,
      output             QSFPB_LP_MODE,
      input              QSFPB_MOD_PRS_n,
      output             QSFPB_MOD_SEL_n,
      input              QSFPB_REFCLK_p,
      output             QSFPB_RST_n,
      input       [3:0]  QSFPB_RX_p,
      output             QSFPB_SCL,
      inout              QSFPB_SDA,
      output      [3:0]  QSFPB_TX_p,
`endif /*ENABLE_QSFPB*/

`ifdef ENABLE_QSFPC
      ///////// QSFPC /////////
      input              QSFPC_INTERRUPT_n,
      output             QSFPC_LP_MODE,
      input              QSFPC_MOD_PRS_n,
      output             QSFPC_MOD_SEL_n,
      input              QSFPC_REFCLK_p,
      output             QSFPC_RST_n,
      input       [3:0]  QSFPC_RX_p,
      output             QSFPC_SCL,
      inout              QSFPC_SDA,
      output      [3:0]  QSFPC_TX_p,
`endif /*ENABLE_QSFPC*/

`ifdef ENABLE_QSFPD
      ///////// QSFPD /////////
      input              QSFPD_INTERRUPT_n,
      output             QSFPD_LP_MODE,
      input              QSFPD_MOD_PRS_n,
      output             QSFPD_MOD_SEL_n,
      input              QSFPD_REFCLK_p,
      output             QSFPD_RST_n,
      input       [3:0]  QSFPD_RX_p,
      output             QSFPD_SCL,
      inout              QSFPD_SDA,
      output      [3:0]  QSFPD_TX_p,
`endif /*ENABLE_QSFPD*/

			//////////// RS422 //////////
			output		          		RJ45_LED_L,
			output		          		RJ45_LED_R,
			output		          		RS422_DE,
			input 		          		RS422_DIN,
			output		          		RS422_DOUT,
			output		          		RS422_RE_n,

      ///////// RZQ /////////
      input              RZQ_DDR3_A,
      input              RZQ_DDR3_B,
      input              RZQ_QDRII_A,
      input              RZQ_QDRII_B,
      input              RZQ_QDRII_C,
      input              RZQ_QDRII_D,

      ///////// SI5340A /////////
      output             SI5340A_I2C_SCL,
      inout              SI5340A_I2C_SDA,
      input              SI5340A_INTR,
      output             SI5340A_OE_n,
      output             SI5340A_RST_n,

      ///////// SI5340B /////////
      output             SI5340B_I2C_SCL,
      inout              SI5340B_I2C_SDA,
      input              SI5340B_INTR,
      output             SI5340B_OE_n,
      output             SI5340B_RST_n,

      ///////// SMA /////////
      input              SMA_CLKIN,
      output             SMA_CLKOUT,

      ///////// SW /////////
      input       [1:0]  SW,

      ///////// TEMP /////////
      output             TEMP_I2C_SCL,
      inout              TEMP_I2C_SDA,
      input              TEMP_INT_n,
      input              TEMP_OVERT_n

);



//=======================================================
//  REG/WIRE declarations
//=======================================================
// QDRII+
parameter QDRII_AVALON_ADDRESS_W = 20; // QDRII avalon bus address width 
parameter QDRII_AVALON_DATA_W = 72; // QDRII avalon bus data width



//=======================================================
//  Structural coding
//=======================================================

//=================================================
//  Configure SI5340B Clocks
`define DDR266_QDR275_PCIE100   4'h0
`define DDR233_QDR275_PCIE100   4'h1
`define DDR200_QDR275_PCIE100   4'h2
`define DDR266_QDR250_PCIE100   4'h3
`define DDR233_QDR250_PCIE100   4'h4
`define DDR200_QDR250_PCIE100   4'h5
`define DDR266_QDR225_PCIE100   4'h6
`define DDR233_QDR225_PCIE100   4'h7
`define DDR200_QDR225_PCIE100   4'h8
`define DDR266_QDR233_PCIE100   4'h9
`define DDR233_QDR233_PCIE100   4'hA
`define DDR200_QDR233_PCIE100   4'hB

wire si5340b_controller_start;
assign si5340b_controller_start = ~CPU_RESET_n;//~BUTTON[0];
wire config_done;


si5340b_controller si5340b_controller(
    .iCLK(CLK_50_B2J),
    .iRST_n(CPU_RESET_n),
    .iStart(si5340b_controller_start),
    .iPLL_OUT_FREQ_SEL(`DDR266_QDR233_PCIE100), //refclock: DDR3 266.66 MHz,QDRII 233.33 MHz, PCIe:100 MHz
    .I2C_CLK(SI5340B_I2C_SCL),
    .I2C_DATA(SI5340B_I2C_SDA),
    .oPLL_REG_CONFIG_DONE(config_done)
);

assign SI5340B_OE_n = 1'b0;
assign SI5340B_RST_n = CPU_RESET_n;





//================================================================
// QDRII+ x4 Test use LFSR pattern

`ifdef ENABLE_QDRIIA

   wire qdriia_afi_clk; // clock for test controllers
	wire qdriia_afi_reset_n; // output from qdrii controller
	
	/// test status ..
	//QDRII+ Verify (A)
	wire qdriia_pass/*synthesis keep*/;
	wire qdriia_test_complete/*synthesis keep*/;
	wire qdriia_local_cal_success/*synthesis keep*/;
	wire qdriia_local_cal_fail/*synthesis keep*/;
   

	assign QDRIIA_ODT = 1'b0;

	QDRII_467_A QDRIIA(
		/*input  wire        */    .global_reset_n(CPU_RESET_n & test_global_reset_n & config_done),             
		/*input  wire        */    .pll_ref_clk(QDRIIA_REFCLK_p),          
		/*input  wire        */    .oct_rzqin(RZQ_QDRII_A),     
      
		/*output wire [0:0]  */    .mem_k(QDRIIA_K_p),               
		/*output wire [0:0]  */    .mem_k_n(QDRIIA_K_n),             
		/*input  wire [0:0]  */    .mem_cq(QDRIIA_CQ_p),              
		/*input  wire [0:0]  */    .mem_cq_n(QDRIIA_CQ_n),            
		/*output wire [21:0] */    .mem_a(QDRIIA_A),               
		/*output wire [1:0]  */    .mem_bws_n(QDRIIA_BWS_n),           
		/*output wire [0:0]  */    .mem_doff_n(QDRIIA_DOFF_n),          
		/*output wire [0:0]  */    .mem_rps_n(QDRIIA_RPS_n),           
		/*output wire [0:0]  */    .mem_wps_n(QDRIIA_WPS_n),           
		/*output wire [17:0] */    .mem_d(QDRIIA_D),               
		/*input  wire [17:0] */    .mem_q(QDRIIA_Q),         
      
		/*output wire        */    .local_cal_success(qdriia_local_cal_success),   
		/*output wire        */    .local_cal_fail(qdriia_local_cal_fail),     
		
		/*output wire        */    .emif_usr_reset_n(qdriia_afi_reset_n),    
		/*output wire        */    .emif_usr_clk(qdriia_afi_clk),    
		
		/*output wire        */    .amm_ready_0(qdriia_avl_r_ready),         
		/*input  wire        */    .amm_read_0(qdriia_avl_r_read_req),          
		/*input  wire [19:0] */    .amm_address_0(qdriia_avl_r_addr),       
		/*output wire [71:0] */    .amm_readdata_0(qdriia_avl_r_rdata),      
		/*input  wire [4:0]  */    .amm_burstcount_0(qdriia_avl_r_size),    
		/*input  wire [7:0]  */    .amm_byteenable_0(8'hFF),    
		/*output wire        */    .amm_readdatavalid_0(qdriia_avl_r_rdata_valid), 
		
		/*output wire        */    .amm_ready_1(qdriia_avl_w_ready),         
		/*input  wire        */    .amm_write_1(qdriia_avl_w_write_req),         
		/*input  wire [19:0] */    .amm_address_1(qdriia_avl_w_addr),       
		/*input  wire [71:0] */    .amm_writedata_1(qdriia_avl_w_wdata),     
		/*input  wire [4:0]  */    .amm_burstcount_1(qdriia_avl_w_size),    
		/*input  wire [7:0]  */    .amm_byteenable_1(8'hFF)
		
  );
				
		/////////////////// QDRII+ SRAM (A) Test  ///////////////////
		wire                               qdriia_avl_w_write_req;            //        qdriia_avl_w.write
		wire                               qdriia_avl_w_ready;                //             .waitrequest_n
		wire [QDRII_AVALON_ADDRESS_W-1:0]  qdriia_avl_w_addr;                 //             .address
		wire [4:0]                         qdriia_avl_w_size;                 //             .burstcount
		wire [QDRII_AVALON_DATA_W-1:0]     qdriia_avl_w_wdata;                //             .writedata
		wire                               qdriia_avl_r_read_req;             //        qdriia_avl_r.read
		wire                               qdriia_avl_r_ready;                //             .waitrequest_n
		wire [QDRII_AVALON_ADDRESS_W-1:0]  qdriia_avl_r_addr;                 //             .address
		wire [4:0]                         qdriia_avl_r_size;                 //             .burstcount
		wire                               qdriia_avl_r_rdata_valid;          //             .readdatavalid
		wire [QDRII_AVALON_DATA_W-1:0]     qdriia_avl_r_rdata;                //             .readdata
		

				Test_QDRIIX1 QDRII_A_VERIFY
						(
						  .avl_w_write_req(qdriia_avl_w_write_req),
						  .avl_w_ready(qdriia_avl_w_ready),
						  .avl_w_addr(qdriia_avl_w_addr),               
						  .avl_w_size(qdriia_avl_w_size),               
						  .avl_w_wdata(qdriia_avl_w_wdata),                         
						  .avl_r_read_req(qdriia_avl_r_read_req),           
						  .avl_r_ready(qdriia_avl_r_ready),           
						  .avl_r_addr(qdriia_avl_r_addr),               
						  .avl_r_size(qdriia_avl_r_size),                
						  .avl_r_rdata_valid(qdriia_avl_r_rdata_valid),         
						  .avl_r_rdata(qdriia_avl_r_rdata),   
						  .afi_clk(qdriia_afi_clk),
						  .afi_reset_n(qdriia_afi_reset_n),
						
						  .local_init_done(qdriia_local_cal_success),
						  .local_cal_success(qdriia_local_cal_success),
						  .local_cal_fail(qdriia_local_cal_fail),					
						
						  .test_reset_n(test_start_n),
						  .test_done(qdriia_test_complete),
						  .test_pass(qdriia_pass)		
						);
						
				
				defparam	QDRII_A_VERIFY.ADDR_W = QDRII_AVALON_ADDRESS_W;
				defparam	QDRII_A_VERIFY.DATA_W = QDRII_AVALON_DATA_W;
		
`endif /*ENABLE_QDRIIA*/




`ifdef ENABLE_QDRIIB
   wire qdriib_afi_clk; // clock for test controllers
	wire qdriib_afi_reset_n; // output from qdrii controller
	
	/// test status ..
	//QDRII+ Verify (B)
	wire qdriib_pass/*synthesis keep*/;
	wire qdriib_test_complete/*synthesis keep*/;
	wire qdriib_local_cal_success/*synthesis keep*/;
	wire qdriib_local_cal_fail/*synthesis keep*/;
   

	assign QDRIIB_ODT = 1'b0;

	QDRII_467_B QDRIIB(
		/*input  wire        */    .global_reset_n(CPU_RESET_n & test_global_reset_n & config_done),             
		/*input  wire        */    .pll_ref_clk(QDRIIB_REFCLK_p),          
		/*input  wire        */    .oct_rzqin(RZQ_QDRII_B),     
      
		/*output wire [0:0]  */    .mem_k(QDRIIB_K_p),               
		/*output wire [0:0]  */    .mem_k_n(QDRIIB_K_n),             
		/*input  wire [0:0]  */    .mem_cq(QDRIIB_CQ_p),              
		/*input  wire [0:0]  */    .mem_cq_n(QDRIIB_CQ_n),            
		/*output wire [21:0] */    .mem_a(QDRIIB_A),               
		/*output wire [1:0]  */    .mem_bws_n(QDRIIB_BWS_n),           
		/*output wire [0:0]  */    .mem_doff_n(QDRIIB_DOFF_n),          
		/*output wire [0:0]  */    .mem_rps_n(QDRIIB_RPS_n),           
		/*output wire [0:0]  */    .mem_wps_n(QDRIIB_WPS_n),           
		/*output wire [17:0] */    .mem_d(QDRIIB_D),               
		/*input  wire [17:0] */    .mem_q(QDRIIB_Q),         
      
		/*output wire        */    .local_cal_success(qdriib_local_cal_success),   
		/*output wire        */    .local_cal_fail(qdriib_local_cal_fail),     
		
		/*output wire        */    .emif_usr_reset_n(qdriib_afi_reset_n),    
		/*output wire        */    .emif_usr_clk(qdriib_afi_clk),    
		
		/*output wire        */    .amm_ready_0(qdriib_avl_r_ready),         
		/*input  wire        */    .amm_read_0(qdriib_avl_r_read_req),          
		/*input  wire [19:0] */    .amm_address_0(qdriib_avl_r_addr),       
		/*output wire [71:0] */    .amm_readdata_0(qdriib_avl_r_rdata),      
		/*input  wire [4:0]  */    .amm_burstcount_0(qdriib_avl_r_size),    
		/*input  wire [7:0]  */    .amm_byteenable_0(8'hFF),    
		/*output wire        */    .amm_readdatavalid_0(qdriib_avl_r_rdata_valid), 
		
		/*output wire        */    .amm_ready_1(qdriib_avl_w_ready),         
		/*input  wire        */    .amm_write_1(qdriib_avl_w_write_req),         
		/*input  wire [19:0] */    .amm_address_1(qdriib_avl_w_addr),       
		/*input  wire [71:0] */    .amm_writedata_1(qdriib_avl_w_wdata),     
		/*input  wire [4:0]  */    .amm_burstcount_1(qdriib_avl_w_size),    
		/*input  wire [7:0]  */    .amm_byteenable_1(8'hFF)
		);
				
		/////////////////// QDRII+ SRAM (B) Test  ///////////////////
		wire                               qdriib_avl_w_write_req;            //        qdriib_avl_w.write
		wire                               qdriib_avl_w_ready;                //             .waitrequest_n
		wire [QDRII_AVALON_ADDRESS_W-1:0]  qdriib_avl_w_addr;                 //             .address
		wire [4:0]                         qdriib_avl_w_size;                 //             .burstcount
		wire [QDRII_AVALON_DATA_W-1:0]     qdriib_avl_w_wdata;                //             .writedata
		wire                               qdriib_avl_r_read_req;             //        qdriib_avl_r.read
		wire                               qdriib_avl_r_ready;                //             .waitrequest_n
		wire [QDRII_AVALON_ADDRESS_W-1:0]  qdriib_avl_r_addr;                 //             .address
		wire [4:0]                         qdriib_avl_r_size;                 //             .burstcount
		wire                               qdriib_avl_r_rdata_valid;          //             .readdatavalid
		wire [QDRII_AVALON_DATA_W-1:0]     qdriib_avl_r_rdata;                //             .readdata
		
				
				Test_QDRIIX1 QDRII_B_VERIFY
						(
						  .avl_w_write_req(qdriib_avl_w_write_req),
						  .avl_w_ready(qdriib_avl_w_ready),
						  .avl_w_addr(qdriib_avl_w_addr),               
						  .avl_w_size(qdriib_avl_w_size),               
						  .avl_w_wdata(qdriib_avl_w_wdata),                         
						  .avl_r_read_req(qdriib_avl_r_read_req),           
						  .avl_r_ready(qdriib_avl_r_ready),           
						  .avl_r_addr(qdriib_avl_r_addr),               
						  .avl_r_size(qdriib_avl_r_size),                
						  .avl_r_rdata_valid(qdriib_avl_r_rdata_valid),         
						  .avl_r_rdata(qdriib_avl_r_rdata),   
						  .afi_clk(qdriib_afi_clk),
						  .afi_reset_n(qdriib_afi_reset_n),
						
						  .local_init_done(qdriib_local_cal_success),
						  .local_cal_success(qdriib_local_cal_success),
						  .local_cal_fail(qdriib_local_cal_fail),					
						
						  .test_reset_n(test_start_n),
						  .test_done(qdriib_test_complete),
						  .test_pass(qdriib_pass)		
						);
				
		
				defparam	QDRII_B_VERIFY.ADDR_W = QDRII_AVALON_ADDRESS_W;
				defparam	QDRII_B_VERIFY.DATA_W = QDRII_AVALON_DATA_W;
		
`endif /*ENABLE_QDRIIB*/




`ifdef ENABLE_QDRIIC

   wire qdriic_afi_clk; // clock for test controllers
	wire qdriic_afi_reset_n; // output from qdrii controller
	
	/// test status ..
	//QDRII+ Verify (C)
	wire qdriic_pass/*synthesis keep*/;
	wire qdriic_test_complete/*synthesis keep*/;
	wire qdriic_local_cal_success/*synthesis keep*/;
	wire qdriic_local_cal_fail/*synthesis keep*/;
   

	assign QDRIIC_ODT = 1'b0;
	
	QDRII_467_C QDRIIC(
		/*input  wire        */    .global_reset_n(CPU_RESET_n & test_global_reset_n & config_done),             
		/*input  wire        */    .pll_ref_clk(QDRIIC_REFCLK_p),          
		/*input  wire        */    .oct_rzqin(RZQ_QDRII_C),     
      
		/*output wire [0:0]  */    .mem_k(QDRIIC_K_p),               
		/*output wire [0:0]  */    .mem_k_n(QDRIIC_K_n),             
		/*input  wire [0:0]  */    .mem_cq(QDRIIC_CQ_p),              
		/*input  wire [0:0]  */    .mem_cq_n(QDRIIC_CQ_n),            
		/*output wire [21:0] */    .mem_a(QDRIIC_A),               
		/*output wire [1:0]  */    .mem_bws_n(QDRIIC_BWS_n),           
		/*output wire [0:0]  */    .mem_doff_n(QDRIIC_DOFF_n),          
		/*output wire [0:0]  */    .mem_rps_n(QDRIIC_RPS_n),           
		/*output wire [0:0]  */    .mem_wps_n(QDRIIC_WPS_n),           
		/*output wire [17:0] */    .mem_d(QDRIIC_D),               
		/*input  wire [17:0] */    .mem_q(QDRIIC_Q),         
      
		/*output wire        */    .local_cal_success(qdriic_local_cal_success),   
		/*output wire        */    .local_cal_fail(qdriic_local_cal_fail),     
		
		/*output wire        */    .emif_usr_reset_n(qdriic_afi_reset_n),    
		/*output wire        */    .emif_usr_clk(qdriic_afi_clk),    
		
		/*output wire        */    .amm_ready_0(qdriic_avl_r_ready),         
		/*input  wire        */    .amm_read_0(qdriic_avl_r_read_req),          
		/*input  wire [19:0] */    .amm_address_0(qdriic_avl_r_addr),       
		/*output wire [71:0] */    .amm_readdata_0(qdriic_avl_r_rdata),      
		/*input  wire [4:0]  */    .amm_burstcount_0(qdriic_avl_r_size),    
		/*input  wire [7:0]  */    .amm_byteenable_0(8'hFF),    
		/*output wire        */    .amm_readdatavalid_0(qdriic_avl_r_rdata_valid), 
		
		/*output wire        */    .amm_ready_1(qdriic_avl_w_ready),         
		/*input  wire        */    .amm_write_1(qdriic_avl_w_write_req),         
		/*input  wire [19:0] */    .amm_address_1(qdriic_avl_w_addr),       
		/*input  wire [71:0] */    .amm_writedata_1(qdriic_avl_w_wdata),     
		/*input  wire [4:0]  */    .amm_burstcount_1(qdriic_avl_w_size),    
		/*input  wire [7:0]  */    .amm_byteenable_1(8'hFF)  
	);

		/////////////////// QDRII+ SRAM (C) Test  ///////////////////
		wire                               qdriic_avl_w_write_req;            //        qdriid_avl_w.write
		wire                               qdriic_avl_w_ready;                //             .waitrequest_n
		wire [QDRII_AVALON_ADDRESS_W-1:0]  qdriic_avl_w_addr;                 //             .address
		wire [4:0]                         qdriic_avl_w_size;                 //             .burstcount
		wire [QDRII_AVALON_DATA_W-1:0]     qdriic_avl_w_wdata;                //             .writedata
		wire                               qdriic_avl_r_read_req;             //        qdriid_avl_r.read
		wire                               qdriic_avl_r_ready;                //             .waitrequest_n
		wire [QDRII_AVALON_ADDRESS_W-1:0]  qdriic_avl_r_addr;                 //             .address
		wire [4:0]                         qdriic_avl_r_size;                 //             .burstcount
		wire                               qdriic_avl_r_rdata_valid;          //             .readdatavalid
		wire [QDRII_AVALON_DATA_W-1:0]     qdriic_avl_r_rdata;                //             .readdata
		

	
	
				Test_QDRIIX1 QDRII_C_VERIFY
						(
						  .avl_w_write_req(qdriic_avl_w_write_req),
						  .avl_w_ready(qdriic_avl_w_ready),
						  .avl_w_addr(qdriic_avl_w_addr),               
						  .avl_w_size(qdriic_avl_w_size),               
						  .avl_w_wdata(qdriic_avl_w_wdata),                         
						  .avl_r_read_req(qdriic_avl_r_read_req),           
						  .avl_r_ready(qdriic_avl_r_ready),           
						  .avl_r_addr(qdriic_avl_r_addr),               
						  .avl_r_size(qdriic_avl_r_size),                
						  .avl_r_rdata_valid(qdriic_avl_r_rdata_valid),         
						  .avl_r_rdata(qdriic_avl_r_rdata),   
						  .afi_clk(qdriic_afi_clk),
						  .afi_reset_n(qdriic_afi_reset_n),
						
						  .local_init_done(qdriic_local_cal_success),
						  .local_cal_success(qdriic_local_cal_success),
						  .local_cal_fail(qdriic_local_cal_fail),					
						
						  .test_reset_n(test_start_n),
						  .test_done(qdriic_test_complete),
						  .test_pass(qdriic_pass)		
						);
						
				
				defparam	QDRII_C_VERIFY.ADDR_W = QDRII_AVALON_ADDRESS_W;
				defparam	QDRII_C_VERIFY.DATA_W = QDRII_AVALON_DATA_W;
		
`endif /*ENABLE_QDRIIC*/




`ifdef ENABLE_QDRIID

   wire qdriid_afi_clk; // clock for test controllers
	wire qdriid_afi_reset_n; // output from qdrii controller
	
	/// test status ..
	//QDRII+ Verify (A)
	wire qdriid_pass/*synthesis keep*/;
	wire qdriid_test_complete/*synthesis keep*/;
	wire qdriid_local_cal_success/*synthesis keep*/;
	wire qdriid_local_cal_fail/*synthesis keep*/;
   
	assign QDRIID_ODT = 1'b0;
	

	QDRII_467_D QDRIID(
		/*input  wire        */    .global_reset_n(CPU_RESET_n & test_global_reset_n & config_done),             
		/*input  wire        */    .pll_ref_clk(QDRIID_REFCLK_p),          
		/*input  wire        */    .oct_rzqin(RZQ_QDRII_D),     
      
		/*output wire [0:0]  */    .mem_k(QDRIID_K_p),               
		/*output wire [0:0]  */    .mem_k_n(QDRIID_K_n),             
		/*input  wire [0:0]  */    .mem_cq(QDRIID_CQ_p),              
		/*input  wire [0:0]  */    .mem_cq_n(QDRIID_CQ_n),            
		/*output wire [21:0] */    .mem_a(QDRIID_A),               
		/*output wire [1:0]  */    .mem_bws_n(QDRIID_BWS_n),           
		/*output wire [0:0]  */    .mem_doff_n(QDRIID_DOFF_n),          
		/*output wire [0:0]  */    .mem_rps_n(QDRIID_RPS_n),           
		/*output wire [0:0]  */    .mem_wps_n(QDRIID_WPS_n),           
		/*output wire [17:0] */    .mem_d(QDRIID_D),               
		/*input  wire [17:0] */    .mem_q(QDRIID_Q),         
      
		/*output wire        */    .local_cal_success(qdriid_local_cal_success),   
		/*output wire        */    .local_cal_fail(qdriid_local_cal_fail),     
		
		/*output wire        */    .emif_usr_reset_n(qdriid_afi_reset_n),    
		/*output wire        */    .emif_usr_clk(qdriid_afi_clk),    
		
			/*output wire        */    .amm_ready_0(qdriid_avl_r_ready),         
		/*input  wire        */    .amm_read_0(qdriid_avl_r_read_req),          
		/*input  wire [19:0] */    .amm_address_0(qdriid_avl_r_addr),       
		/*output wire [71:0] */    .amm_readdata_0(qdriid_avl_r_rdata),      
		/*input  wire [4:0]  */    .amm_burstcount_0(qdriid_avl_r_size),    
		/*input  wire [7:0]  */    .amm_byteenable_0(8'hFF),    
		/*output wire        */    .amm_readdatavalid_0(qdriid_avl_r_rdata_valid), 
		
		/*output wire        */    .amm_ready_1(qdriid_avl_w_ready),         
		/*input  wire        */    .amm_write_1(qdriid_avl_w_write_req),         
		/*input  wire [19:0] */    .amm_address_1(qdriid_avl_w_addr),       
		/*input  wire [71:0] */    .amm_writedata_1(qdriid_avl_w_wdata),     
		/*input  wire [4:0]  */    .amm_burstcount_1(qdriid_avl_w_size),    
		/*input  wire [7:0]  */    .amm_byteenable_1(8'hFF)  
	);
				
		/////////////////// QDRII+ SRAM (D) Test  ///////////////////
		wire                               qdriid_avl_w_write_req;            //        qdriid_avl_w.write
		wire                               qdriid_avl_w_ready;                //             .waitrequest_n
		wire [QDRII_AVALON_ADDRESS_W-1:0]  qdriid_avl_w_addr;                 //             .address
		wire [4:0]                         qdriid_avl_w_size;                 //             .burstcount
		wire [QDRII_AVALON_DATA_W-1:0]     qdriid_avl_w_wdata;                //             .writedata
		wire                               qdriid_avl_r_read_req;             //        qdriid_avl_r.read
		wire                               qdriid_avl_r_ready;                //             .waitrequest_n
		wire [QDRII_AVALON_ADDRESS_W-1:0]  qdriid_avl_r_addr;                 //             .address
		wire [4:0]                         qdriid_avl_r_size;                 //             .burstcount
		wire                               qdriid_avl_r_rdata_valid;          //             .readdatavalid
		wire [QDRII_AVALON_DATA_W-1:0]     qdriid_avl_r_rdata;                //             .readdata
		

				
				Test_QDRIIX1 QDRII_D_VERIFY
						(
						  .avl_w_write_req(qdriid_avl_w_write_req),
						  .avl_w_ready(qdriid_avl_w_ready),
						  .avl_w_addr(qdriid_avl_w_addr),               
						  .avl_w_size(qdriid_avl_w_size),               
						  .avl_w_wdata(qdriid_avl_w_wdata),                         
						  .avl_r_read_req(qdriid_avl_r_read_req),           
						  .avl_r_ready(qdriid_avl_r_ready),           
						  .avl_r_addr(qdriid_avl_r_addr),               
						  .avl_r_size(qdriid_avl_r_size),                
						  .avl_r_rdata_valid(qdriid_avl_r_rdata_valid),         
						  .avl_r_rdata(qdriid_avl_r_rdata),   
						  .afi_clk(qdriid_afi_clk),
						  .afi_reset_n(qdriid_afi_reset_n),
						
						  .local_init_done(qdriid_local_cal_success),
						  .local_cal_success(qdriid_local_cal_success),
						  .local_cal_fail(qdriid_local_cal_fail),					
						
						  .test_reset_n(test_start_n),
						  .test_done(qdriid_test_complete),
						  .test_pass(qdriid_pass)		
						);
		 		
				defparam	QDRII_D_VERIFY.ADDR_W = QDRII_AVALON_ADDRESS_W;
				defparam	QDRII_D_VERIFY.DATA_W = QDRII_AVALON_DATA_W;
			
		
`endif /*ENABLE_QDRIID*/

//////////////////////////////////////////////
// reset_n and start_n control
wire test_global_reset_n/*synthesis keep*/;
wire test_start_n/*synthesis keep*/;


reg [31:0]  cont;
always@(posedge CLK_50_B2J)
cont<=(cont==32'd4_000_001)?32'd0:cont+1'b1;

reg[4:0] sample;
always@(posedge CLK_50_B2J)
begin
	if(cont==32'd4_000_000)
		sample[4:0]={sample[3:0],BUTTON[0]};
	else 
		sample[4:0]=sample[4:0];
end

assign test_global_reset_n   =(sample[3:2]==2'b10)?1'b0:1'b1;
assign test_start_n          =(&sample==0)        ?1'b0:1'b1;

assign LED = {~(qdriid_local_cal_success & qdriid_pass & qdriid_test_complete),
              ~(qdriic_local_cal_success & qdriic_pass & qdriic_test_complete),
				  ~(qdriib_local_cal_success & qdriib_pass & qdriib_test_complete),
				  ~(qdriia_local_cal_success & qdriia_pass & qdriia_test_complete)};
				  
//=====================================
wire QDRIIA_1Hz ; 
wire QDRIIB_1Hz ; 
wire QDRIIC_1Hz ; 
wire QDRIID_1Hz ; 

heart_beat  heart_beat_qdriia_refclk (.CLK  (QDRIIA_REFCLK_p), .CLK_FREQ (233_333_333), .CK_1HZ (QDRIIA_1Hz) ) ;
heart_beat  heart_beat_qdriib_refclk (.CLK  (QDRIIB_REFCLK_p), .CLK_FREQ (233_333_333), .CK_1HZ (QDRIIB_1Hz) ) ;
heart_beat  heart_beat_qdriic_refclk (.CLK  (QDRIIC_REFCLK_p), .CLK_FREQ (233_333_333), .CK_1HZ (QDRIIC_1Hz) ) ;
heart_beat  heart_beat_qdriid_refclk (.CLK  (QDRIID_REFCLK_p), .CLK_FREQ (233_333_333), .CK_1HZ (QDRIID_1Hz) ) ;				  

				  
assign LED_BRACKET = {QDRIID_1Hz,QDRIIC_1Hz,QDRIIB_1Hz,QDRIIA_1Hz};
				  
endmodule
